package adressa;

import global.GlobalParameters;

import util.LogHelper;
import weka.core.Instances;
import weka.core.SparseInstance;
import weka.core.converters.ConverterUtils.DataSource;
import weka.core.Utils;
import weka.classifiers.Classifier;
import weka.classifiers.Evaluation;

import weka.classifiers.bayes.NaiveBayes;
import weka.classifiers.functions.SMO;
import weka.classifiers.trees.J48;
import weka.core.converters.ArffSaver;
import weka.core.converters.TextDirectoryLoader;
import weka.filters.Filter;
import weka.filters.unsupervised.attribute.StringToWordVector;
import weka.filters.unsupervised.instance.NonSparseToSparse;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Random;



public class AdressaClassifierTextRank {

	public AdressaClassifierTextRank(){

	}

	public void runClassifier() throws Exception{

		TextDirectoryLoader loader = new TextDirectoryLoader();
		//		loader.setDirectory(new File(GlobalParameters.ADRESSA_CLASSIFIER_PATH));
		loader.setDirectory(new File("resources/adressa/textRankTrain"));
		//		loader.setDirectory(new File(GlobalParameters.TEXTRANK_CLASSIFIER_PATH));
		//		loader.setDirectory(new File("resources/documents/textRankClassifier"));
		Instances dataRaw = loader.getDataSet();  // contains the full dataset we wann create train/test sets from
		int seed = 6;          // the seed for randomizing the data
		int folds = 10;         // the number of folds to generate, >=2

		StringToWordVector filter = new StringToWordVector();

		String[] filterOptArr = new String[2];
		filterOptArr[0] = "-N";
		filterOptArr[1] = "1";
		filter.setInputFormat(dataRaw);
		filter.setOutputWordCounts(true);
		filter.setOptions(filterOptArr);
		String[] optArr = new String[2];
		optArr[0] = "-delimiters";
		optArr[1] = ",";
		filter.getTokenizer().setOptions(optArr);

		//		String[] optArr = new String[2];
		//		optArr[0] = "-delimiters";
		//		optArr[1] = ",";
		//		filter.getTokenizer().setOptions(optArr);
		//
		//		filter.setInputFormat(dataRaw);

		Instances dataFiltered = Filter.useFilter(dataRaw, filter);
//		dataFiltered = convertToSparseInstance(dataFiltered);



		//		int runs = 3;
		//		for (int i = 0; i < runs; i++) {
		//			seed = i+1;
		//			Random rand = new Random(seed);   // create seeded number generator
		//			Instances randData = new Instances(dataFiltered);   // create copy of original data
		//			randData.randomize(rand);         // randomize data with number generator
		////			randData.stratify(folds);
		//
		//			for (int n = 0; n < folds; n++) {
		//				Instances train = randData.trainCV(folds, n);
		//				Instances test = randData.testCV(folds, n);
		//				randData.delete();

		//		Classifier nb = (Classifier)new NaiveBayes();
		//		nb.buildClassifier(dataFiltered);
		
		SMO smoClassifier = new SMO();
		smoClassifier.buildClassifier(dataFiltered);

//		Classifier j48 = (Classifier)new J48();
//		j48.buildClassifier(dataFiltered);

//		System.out.println("j48");
//
//		System.out.println("\n\nClassifier model:\n\n" + j48);

		//		System.out.println("NAIVE BAYES");

//		dataFiltered.delete();
		//		System.out.println("\n\nClassifier model:\n\n" + nb);

		loader.setDirectory(new File("resources/adressa/textRankTest"));

		Instances testDataRaw = loader.getDataSet();
		testDataRaw = convertToSparseInstance(testDataRaw);
		    
		filter = new StringToWordVector();
		
//		BayesianLogisticRegression


		filter.setInputFormat(dataRaw);
		filter.setOutputWordCounts(true);
		filter.setOptions(filterOptArr);

		filter.getTokenizer().setOptions(optArr);
		Instances testDataFiltered = Filter.useFilter(testDataRaw, filter);
		// Test the model
//		Evaluation nbTest = new Evaluation(testDataFiltered);
//		nbTest.evaluateModel(j48, testDataFiltered);

		// Print the result  la Weka explorer:
//		String strSummary = nbTest.toSummaryString();
//		System.out.println(strSummary);

		
		Evaluation smoTest = new Evaluation(testDataFiltered);
		smoTest.evaluateModel(smoClassifier, testDataFiltered);

		// Print the result  la Weka explorer:
		String strSmoSummary = smoTest.toSummaryString();
		System.out.println(strSmoSummary);

		// further processing, classification, etc.

	}
	//		}
	//	}

	public Instances convertToSparseInstance(Instances instance) throws Exception{
		Instances source  = instance;
		NonSparseToSparse sp = new NonSparseToSparse();
		sp.setInputFormat(source);
		Instances newData = Filter.useFilter(source, sp);
//		ArffSaver saver = new ArffSaver();
//		saver.setInstances(newData);
//		saver.setFile(new File("cpusparse.arff"));
//		saver.writeBatch(); 
		return newData;
	}

	public static void main(String[] args) throws Exception {
		AdressaClassifierTextRank aClass = new AdressaClassifierTextRank();
		File dir = new File(GlobalParameters.LOGFILE+aClass.getClass().getName());
		if(!dir.isDirectory()){
			dir.mkdir();
		}
		PrintStream ps = new PrintStream(new File(LogHelper.getLogName()));
		System.setOut(ps);
		aClass.runClassifier();
	}

}

