package adressa;

import java.util.ArrayList;
import java.util.List;

import taggerAndWordbank.impl.OsloBergenTagger;
import util.FileWriterHelper;

public class AdressaTagAndSave {

	private String serverUrl = "http://slt.idi.ntnu.no:15100";
	private String xmlUrl;
	private List<AdressaDocument> docs;
	private OsloBergenTagger obt;
	private AdressaSAXParser saxParser;

	public AdressaTagAndSave(String startXmlUrl){
		xmlUrl = startXmlUrl;
		saxParser = new AdressaSAXParser();
		try {
			obt = new OsloBergenTagger();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void tagAndSave(){
		while(xmlUrl!=null){
			saxParser.parse(serverUrl+xmlUrl);
			docs = saxParser.getDocs();
			for(AdressaDocument d: docs){
				System.out.println(d.getTitleString());
				String taggedText = d.generateTaggedDocumentString(obt);
				FileWriterHelper.writeFile("resources/adressa/" + d.getTitleString()+".txt", taggedText);
			}
			saxParser.setDocs(new ArrayList<AdressaDocument>());
			if(xmlUrl == saxParser.getNextPage()){
				break;
			}
			else{
				xmlUrl = saxParser.getNextPage();
			}
		}
	}
	
	public static void main(String[] args) {
		AdressaTagAndSave atas = new AdressaTagAndSave("/cgi-bin/xsearch?offset=0&hits=10&view=adressa&offset=3950");
		atas.tagAndSave();
	}

}
