package adressa;

import global.GlobalParameters;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import util.FileReaderHelper;
import util.FileWriterHelper;
import util.StringHelper;
import weka.core.Instances;
import weka.core.converters.ArffSaver;
import weka.core.converters.TextDirectoryLoader;
import weka.filters.Filter;
import weka.filters.unsupervised.attribute.Standardize;
import weka.filters.unsupervised.attribute.StringToWordVector;
import weka.filters.unsupervised.instance.NonSparseToSparse;

public class ArffGenerator {
	private int[] emptyArr;

	public void generateArff(File file) throws Exception{
		TextDirectoryLoader loader = new TextDirectoryLoader();
		loader.setDirectory(file);
		Instances dataRaw = loader.getDataSet();  // contains the full dataset we wann create train/test sets from
		System.out.println(dataRaw.firstInstance());
		StringToWordVector filter = new StringToWordVector();
		//		Standardize standardizeFilter = new Standardize();

		String[] filterOptArr = new String[2];
		filterOptArr[0] = "-N";
		filterOptArr[1] = "1";
		filter.setInputFormat(dataRaw);
		//		filter.setOutputWordCounts(true);
		//		filter.setOptions(filterOptArr);
		String[] optArr = new String[2];
		optArr[0] = "-delimiters";
		optArr[1] = ",";
		filter.getTokenizer().setOptions(optArr);

		System.out.println(dataRaw.firstInstance());
		Instances dataFiltered;
		//		dataRaw = convertToSparseInstance(dataRaw);
		//		standardizeFilter.setInputFormat(dataRaw);
		dataFiltered = Filter.useFilter(dataRaw, filter);
		int numOfAtt = dataFiltered.numAttributes();
		emptyArr = new int[numOfAtt];
		for(int i =0;i<numOfAtt;i++){
			emptyArr[i]=0;
		}
		//		System.out.println(dataFiltered.firstInstance());
		//		System.out.println();
		//		for(int i=0;i<numOfAtt;i++){
		//			System.out.print(attr[i] + ",");
		//		}


		writeToArff(dataFiltered);
	}

	public Instances convertToSparseInstance(Instances instance) throws Exception{
		Instances source  = instance;
		NonSparseToSparse sp = new NonSparseToSparse();
		sp.setInputFormat(source);
		Instances newData = Filter.useFilter(source, sp);
		//		ArffSaver saver = new ArffSaver();
		//		saver.setInstances(newData);
		//		saver.setFile(new File("resources/cpusparse.arff"));
		//		saver.writeBatch(); 
		return newData;
	}

	public void writeToArff(Instances instances) throws Exception{
		ArffSaver saver = new ArffSaver();
		saver.setInstances(instances);
		saver.setFile(new File("resources/multiclass.arff"));
		saver.writeBatch(); 
	}

	public void generateClasses(File file){
		String classes ="";
		for(File category: file.listFiles()){
			String name = "@attribute " + category.getName() + " {0, 1}";
			classes += name + "\n";
		}
		FileWriterHelper.writeFile("resources/classes.txt", classes);
	}

	public void reformatInstances(File file){
		StringBuilder fileString= new StringBuilder();
		boolean data = false;
		try {
			//			FileOutputStream fos = new FileOutputStream(new File("resources/multiclass.arff"));
			//			OutputStreamWriter osw = new OutputStreamWriter(fos);
			//			PrintWriter pw = new PrintWriter(osw);

			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String aLine = br.readLine();
			//			int[] attrArr = emptyArr.clone();
			while(aLine != null){
				if(data){
					//					aLine=aLine.replace("{", "");
					//					aLine=aLine.replace("}", "");
					aLine = aLine.substring(0, aLine.length()-1) +",41281 1}";
					int start = aLine.indexOf(",");
					if(start>0){

						String firstEntry = aLine.substring(1,start);
						if(!StringHelper.isNoLetters(firstEntry)){
							aLine = aLine.substring(0,1) + aLine.substring(start+1, aLine.length()-1) +",41280 1}";
						}
						//						String[] lineArr = aLine.split(",");
						//						for(String s: lineArr){
						//							
						//							int index = Integer.valueOf(s.substring(0, s.indexOf(" ")));
						//							int value = Integer.valueOf(s.substring(s.indexOf(" "), s.length()-1));
						//							attrArr[index] = value;
						//							System.out.println(s + "         vaL: " + value + " index: " + index );
						//						}
					}
					else{
						System.out.println("start<0: " + start);
					}


				}
				if(aLine.startsWith("@data")){
					data=true;
				}


				//				int start = aLine.indexOf(",");
				//				aLine = aLine.substring(start, aLine.length()-1);
				//								fileString += aLine + "\n";
				fileString.append(aLine + "\n");
				//				for(int k: attrArr){
				//					pw.print(k+",");
				//				}
				//				pw.print("\n");
				//				fileString.append("\n");
				aLine = br.readLine();
			}
			//			pw.close();
		}
		catch(IOException e){
			e.printStackTrace();
		}

		FileWriterHelper.writeFile("resources/multiclass.arff", fileString.toString());
	}


	public static void main(String[] args) throws Exception {
		ArffGenerator ag = new ArffGenerator();
//		ag.generateArff(new File("resources/adressa/textRank"));
//		ag.generateClasses(new File("resources/adressa/textRank"));
		ag.reformatInstances(new File("resources/multiclass.arff"));
	}

}
