package adressa;

import global.GlobalParameters;

import java.io.File;
import java.util.HashMap;
import java.util.HashSet;

import keyphraseExtraction.impl.StopwordReader;
import keyphraseExtraction.impl.TaggedTextSplitter;

import util.FileReaderHelper;
import util.FileWriterHelper;
import util.HtmlTagHelper;
import util.StringHelper;

public class Baseline {

	public void run(){
		TaggedTextSplitter tt = new TaggedTextSplitter();
		StopwordReader stopwordReader = new StopwordReader(new File(GlobalParameters.STOP_WORD_LIST));
		HashSet<String> stopWordMap = stopwordReader.getStopwordMap();
		File dir = new File(GlobalParameters.EVALUATION_DOCS_PATH);
		File baseline = new File("resources/adressa/baseline");
		for(File category: baseline.listFiles()){
			category.delete();
		}

		if(dir.isDirectory()){
			File[] files = dir.listFiles();

			for(File file : files){
				if(file.isDirectory()){
					File newDir = new File(baseline + "/" + file.getName());
					if(!newDir.isDirectory()){
						newDir.mkdir();
					}
					File[] taggedTexts = file.listFiles();
					for(File textFile: taggedTexts){
						String fileString = null;
						String text = FileReaderHelper.readFileToString(textFile);
						text = HtmlTagHelper.removeTitleAndHeader(text);
						tt.split(text);
						String[] textArr = tt.getTextArr();
						for(String s: textArr){
							if(!stopWordMap.contains(s) && !StringHelper.isNoLetters(s) && s!=null){
								fileString += s + ",";
							}
						}
						FileWriterHelper.writeFile(baseline + "/" + file.getName() + "/" + textFile.getName(), fileString);
					}
				}

			}
		}
	}
	
	public static void main(String[] args) {
		Baseline b = new Baseline();
		b.run();
	}
}