package adressa;

import global.GlobalParameters;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;

import util.CopyFile;
import util.FileReaderHelper;
import util.FileWriterHelper;
import util.HtmlTagHelper;

public class DocumentPlacer {

	public DocumentPlacer(){

	}
	
	public void placeEvaluationDocuments(HashSet<String> categoriesSet){
		File dir = new File(GlobalParameters.ADRESSA_CLASSIFIER_PATH);
		if(dir.isDirectory()){
			File[] categories = dir.listFiles();
			for(File category:categories){
				if(!categoriesSet.contains(category.getName())){
					continue;
				}
				File newDir = new File("resources/adressa/evaluationDocuments" + "/" +category.getName());
				if(!newDir.isDirectory()){
					newDir.mkdir();
				}
				if(category.isDirectory()){
					for(File doc: category.listFiles()){
						String[] contentArr = HtmlTagHelper.adressaContentToArray(doc);
						String output = "*TITLE*" + contentArr[1] + "*/TITLE*" + "\n" + "*HEADER*" + contentArr[2] + "*/HEADER*" + "\n" + contentArr[3];
						FileWriterHelper.writeFile("resources/adressa/evaluationDocuments" + "/" +category.getName()+"/"+doc.getName(), output);
					}
				}
			}
		}
	}
	
	public void placeDocumentsInFolders(){
		File dir = new File(GlobalParameters.ADRESSA_DOCUMENT_PATH);
		if(dir.isDirectory()){
			File[] files = dir.listFiles();

			for(File file : files){
				if(file.isDirectory()){
					continue;
				}
				try{
					String[] contentArr = HtmlTagHelper.adressaContentToArray(file);
					String tagString = contentArr[0];
					if(tagString==null || tagString.isEmpty()){
						continue;
					}
					String[] tags = tagString.split(";");
					for(String tag: tags){
						System.out.println(tag);
						int splitPoint=tag.indexOf("/");
						System.out.println(splitPoint);
						if(splitPoint!=-1){
							tag=tag.substring(0, splitPoint);
						}
						File newDir = new File(GlobalParameters.ADRESSA_CLASSIFIER_PATH + "/" +tag);
						if(!newDir.isDirectory()){
							newDir.mkdir();
						}
						String output = "*TAGS*" + contentArr[0] + "*/TAGS*" + "\n" + "*TITLE*" + contentArr[1] + "*/TITLE*" + "\n" + "*HEADER*" + contentArr[2] + "*/HEADER*" + "\n" + contentArr[3];

//						String output = "*TITLE*" + contentArr[1] + "*/TITLE*" + "\n" + "*HEADER*" + contentArr[2] + "*/HEADER*" + "\n" + contentArr[3];
						FileWriterHelper.writeFile(GlobalParameters.ADRESSA_CLASSIFIER_PATH + "/" +tag+"/"+file.getName(), output);
						//						CopyFile.copyfile(file.getPath(), GlobalParameters.ADRESSA_CLASSIFIER_PATH + "/" +tag+"/"+file.getName());
//						break;
					}

				}
				catch(Exception e){
					e.printStackTrace();
				}
			}

		}
	}
	
	public void placeDocumentsInFolders(String keytag){
		File dir = new File(GlobalParameters.ADRESSA_DOCUMENT_PATH);
		if(dir.isDirectory()){
			File[] files = dir.listFiles();

			for(File file : files){
				if(file.isDirectory()){
					continue;
				}
				try{
					String[] contentArr = HtmlTagHelper.adressaContentToArray(file);
					String tagString = contentArr[0];
					if(tagString==null || tagString.isEmpty()){
						continue;
					}
					String[] tags = tagString.split(";");
					for(String tag: tags){
						if(tag.equals(keytag)){
							System.out.println(tag);
							int splitPoint=tag.indexOf("/");
//							System.out.println(splitPoint);
							if(splitPoint!=-1){
								tag=tag.substring(0, splitPoint);
							}
							File newDir = new File("resources/adressa/singleCategory" + "/" +tag);
							if(!newDir.isDirectory()){
								newDir.mkdir();
							}
//							"*TAGS*" + contentArr[0] + "*/TAGS*" + "\n" +
							String output =  "*TITLE*" + contentArr[1] + "*/TITLE*" + "\n" + "*HEADER*" + contentArr[2] + "*/HEADER*" + "\n" + contentArr[3];

//							String output = "*TITLE*" + contentArr[1] + "*/TITLE*" + "\n" + "*HEADER*" + contentArr[2] + "*/HEADER*" + "\n" + contentArr[3];
							FileWriterHelper.writeFile("resources/adressa/singleCategory"+ "/" +tag+"/"+file.getName(), output);

						}
						else{
							int splitPoint=tag.indexOf("/");
//							System.out.println(splitPoint);
							if(splitPoint!=-1){
								tag=tag.substring(0, splitPoint);
							}
							File newDir = new File("resources/adressa/singleCategory" + "/others");
							if(!newDir.isDirectory()){
								newDir.mkdir();
							}
//							"*TAGS*" + contentArr[0] + "*/TAGS*" + "\n" +
							String output =  "*TITLE*" + contentArr[1] + "*/TITLE*" + "\n" + "*HEADER*" + contentArr[2] + "*/HEADER*" + "\n" + contentArr[3];

//							String output = "*TITLE*" + contentArr[1] + "*/TITLE*" + "\n" + "*HEADER*" + contentArr[2] + "*/HEADER*" + "\n" + contentArr[3];
							FileWriterHelper.writeFile("resources/adressa/singleCategory"+ "/others" +"/"+file.getName(), output);
						}
//												//						CopyFile.copyfile(file.getPath(), GlobalParameters.ADRESSA_CLASSIFIER_PATH + "/" +tag+"/"+file.getName());
//						break;
					}

				}
				catch(Exception e){
					e.printStackTrace();
				}
			}

		}
	}

	public static void main(String[] args) {
		DocumentPlacer docP = new DocumentPlacer();
//		docP.placeDocumentsInFolders();
		docP.placeDocumentsInFolders("NRK");
	}
}
