package adressa;

import global.GlobalParameters;

import java.io.File;
import java.util.HashSet;

import util.CopyFile;

public class RandomTestSetGenerator {
	
	private String method = "wRAKE";
	
	private File path = new File("resources/adressa/" + method);
	private File testPath = new File("resources/adressa/" + method + "Test");
	private File trainPath = new File("resources/adressa/" + method + "Train");
	
	public RandomTestSetGenerator(){
		
	}
	
	public void run(){
		if(path.isDirectory()){
			File[] categories = path.listFiles();
			for(File category: categories){
				if(category.isDirectory()){
					File[] docs = category.listFiles();
					if(docs.length<5){
						continue;
					}
					File newDir = new File(testPath + "/" +category.getName());
					if(!newDir.isDirectory()){
						newDir.mkdir();
					}
					newDir = new File(trainPath + "/" +category.getName());
					if(!newDir.isDirectory()){
						newDir.mkdir();
					}
					
//					System.out.println(docs.length);
					int noOfDocs = (int)Math.round(docs.length*0.2);
					HashSet<Integer> testDocs = new HashSet<Integer>();
//					System.out.println(noOfDocs);
					for(int i=0;i<noOfDocs;i++){
						int temp = (int)Math.rint((docs.length-1)*Math.random());
//						System.out.println("temp: " + temp);
						if(testDocs.contains(temp)){
							int testCount = 0;
							while(testDocs.contains(temp)){
								testCount++;
								temp = (int)Math.rint((docs.length-1)*Math.random());
								if(testCount>100000){
									testCount=0;
									System.out.println(noOfDocs);
								}
							}
							testDocs.add(temp);
						}
						else{
							testDocs.add(temp);
						}
					}
					for(int i: testDocs){
						File newFile = docs[i];
						CopyFile.copyfile(newFile.getPath(), testPath + "/" +category.getName()+"/"+newFile.getName());
					}
					for(int j=0;j<docs.length;j++){
						if(!testDocs.contains(j)){
							File newFile = docs[j];
							CopyFile.copyfile(newFile.getPath(), trainPath + "/" +category.getName()+"/"+newFile.getName());
						}
						
					}
					
				}
				else{
					System.out.println("not a category");
				}
			}
			
		}
		else{
			System.out.println("not a dir");
		}
	}
	
	public static void main(String[] args) {
		RandomTestSetGenerator randTSG = new RandomTestSetGenerator();
		randTSG.run();
	}

}
