package classifer.impl;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map.Entry;

import util.FileReaderHelper;
import weka.core.tokenizers.Tokenizer;
import keyphraseExtraction.Phrase;

public class PhraseTokenizer {
	
//	public String readKeywordsToClassifierString(File file){
//		String fileString = FileReaderHelper.readFileToString(file);
//	}
	
	public String makeTokens(List<Phrase> phrases){
		String tokenString = "";
		for(Phrase p: phrases){
			tokenString += makeToken(p);
		}
		return tokenString;
	}
	
	public String makeTokens(ArrayList<Entry<String, Double>> phrases){
		String tokenString = "";
		for(Entry<String, Double> e: phrases){
			int count = (int) Math.round((double) e.getValue());
			tokenString += makeToken(e.getKey(), count);
		}
		return tokenString;
	}
	
	public String makeToken(String name, int count){
		StringBuilder sb = new StringBuilder();
		for(int i=0;i<count;i++){
			sb.append(name + ",");
		}
		return sb.toString();
	}
	
	public String makeToken(Phrase phrase){
		String name = phrase.getPhraseToString();
		int count = (int) Math.floor(phrase.getScore());
		count = 1;
		StringBuilder sb = new StringBuilder();
		for(int i=0;i<count;i++){
			sb.append(name + ",");
		}
		return sb.toString();
	}

}