package clustering.impl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import keyphraseExtraction.Phrase;
import keyphraseExtraction.impl.TaggerExtractor;
import keyphraseExtraction.impl.NounWBKeywordExtractor;
import keyphraseExtraction.impl.PhraseImpl;

import util.PhraseComparator;
import util.WordLengthComparator;

public class PhraseClusteringWb {
	
	private NounWBKeywordExtractor NWBExtractor;

	public List<Phrase> cluster(List<Phrase> entries, NounWBKeywordExtractor NWBExtractor){
		this.NWBExtractor = NWBExtractor;
		HashSet<String> hashEntries = new HashSet<String>();
		HashMap<String,List<Phrase>> clusterMap = new HashMap<String, List<Phrase>>();


		Collections.sort(entries, new WordLengthComparator());
		//TODO: fix

		Iterator<Phrase> i = entries.iterator();
		while(i.hasNext()){
			Phrase phrase = i.next();
//			System.out.println(phrase.getPhraseToString());
			String returnWord = containsSubString(hashEntries, phrase);
			if(!returnWord.isEmpty()){
				//				if(clusterMap.containsKey(returnWord)){

				System.out.println(returnWord);
				clusterMap.get(returnWord).add(phrase);		
				//				}
			}
			ArrayList<Phrase> arr = new ArrayList<Phrase>();
			arr.add(phrase);
			clusterMap.put(phrase.getPhraseToString(), arr);

			hashEntries.add(phrase.getPhraseToString());
		}
//		for(String s: hashEntries){
//			System.out.println("PHRASECLUSTERINGWB."+s);
//		}

		return calculatePhraseScore(clusterMap);
	}

	public String containsSubString(HashSet<String> hashEntries, Phrase phrase){
		ArrayList<String> word = phrase.getPhrase();
		//			String[] wordSplit = word.split(" ");
		String temp="";
		for(int i=0;i<word.size();i++){
			temp = word.get(i);
			if(hashEntries.contains(temp) && NWBExtractor.containsNoun(temp)){

				return temp;
			}
			for(int j=i+1;j<word.size();j++){
				temp += " " + word.get(j);
//				System.out.println("PHRASECLUSTERINGWB.TEMP: " + temp);
				if(hashEntries.contains(temp) && NWBExtractor.containsNoun(temp)){
//					System.out.println("PHRASECLUSTERINGWB.MATCH");
					return temp;
				}
			}
		}
		return "";
	}

	public List<Phrase> calculatePhraseScore(HashMap<String, List<Phrase>> clusterMap){
		List<Phrase> phrasesWithScore = new ArrayList<Phrase>();
		Iterator<String> i = clusterMap.keySet().iterator();
		while(i.hasNext()){	
			String key = (String)i.next();

//			System.out.println("PHRASECLUSTERINGWB.PHRASE " + key);

			List<Phrase> phrases = clusterMap.get(key);
			double score = 0;
			for(Phrase p: phrases){
//				System.out.println("PHRASECLUSTERINGWB.PHRASE CONTAINS " + p.getPhrase() + " with score " + p.getScore());
				score += p.getScore();
			}
			ArrayList<String> keyArr = new ArrayList<String>();
			keyArr.add(key);
			phrasesWithScore.add(new PhraseImpl(keyArr, score));
		}
		Collections.sort(phrasesWithScore, new PhraseComparator());

		phrasesWithScore = removeLowerRankedFromSameCluster(phrasesWithScore);

		return phrasesWithScore;
	}

	public String toString(List<Phrase> phrases){
		String str = "";
//		System.out.println("PHRASECLUSTERINGWB.NUMBER OF PHRASES: " + phrases.size());
		for(Phrase p: phrases){
			str += p.getPhrase() + "=" + p.getScore() + "\n";
		}
		return str;
	}

	/**
	 * Removes entries that are in a cluster that is higher ranked from the list. 
	 * Requires the list to be sorted from highest to lowest score.
	 * @param clusterMap
	 * @return
	 */
	public List<Phrase> removeLowerRankedFromSameCluster( List<Phrase> phraseList){
		HashSet<String> phraseWords = new HashSet<String>();
		List<Phrase> copyList = new ArrayList<Phrase>();
		copyList.addAll(phraseList);
		for(Phrase p: copyList){
			for(String s: phraseWords){
				if(p.getPhraseToString().contains(s)){
					phraseList.remove(p);
					break;
				}
			}
			phraseWords.add(p.getPhraseToString());
		}
		return phraseList;
	}
}

