package clustering.impl;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import keyphraseExtraction.Phrase;
import keyphraseExtraction.impl.PhraseImpl;

public class SingleWordRemover {

	public SingleWordRemover() {


	}

	public List<Phrase> removeSingleWords(List<Phrase> phrases){
		HashSet<String> words = makeWordDictionary(phrases);
		phrases = findPhrasesToRemove(phrases, words);
		return phrases;
	}
	
	private HashSet<String> makeWordDictionary(List<Phrase> phrases){
		HashSet<String> words = new HashSet<String>();
		for(Phrase p: phrases){
			if(p.getWordLength()>1){
				words.addAll(p.getPhrase());			
			}
		}
		return words;
	}
	
	private List<Phrase> findPhrasesToRemove(List<Phrase> phrases, HashSet<String> words){
		List<Phrase> phrasesToRemove = new ArrayList<Phrase>();
		for(Phrase p:phrases){
			if(p.getWordLength() ==1){
				if(!words.contains(p.getPhraseToString())){
					phrasesToRemove.add(p);
				}
			}
		}
		phrases.removeAll(phrasesToRemove);
		return phrases;
	}
	
	private static ArrayList<String> stringToArrayList(String phraseString){
		ArrayList<String> phraseList = new ArrayList<String>();
		String[] splitArr = phraseString.split(" ");
		for(String s: splitArr){
			phraseList.add(s);
		}
		return phraseList;
	}
	
	public static void main(String[] args){
		
		Phrase p1 = new PhraseImpl(stringToArrayList("arne banan"));
		Phrase p2 = new PhraseImpl(stringToArrayList("arne"));
		Phrase p3 = new PhraseImpl(stringToArrayList("bananas"));
		List<Phrase> phraseList = new ArrayList<Phrase>();
		phraseList.add(p1);
		phraseList.add(p2);
		phraseList.add(p3);
		SingleWordRemover sr = new SingleWordRemover();
		phraseList = sr.removeSingleWords(phraseList);
		for(Phrase p:phraseList){
			System.out.println(p.getPhraseToString());
		}
	}

}
