package global;

import java.util.List;

public class GlobalParameters {

	public final static String DOCUMENT_PATH = "resources/documents/";
	
//	public final static String STOP_WORD_LIST = "resources/stopword300.txt";
	public final static String STOP_WORD_LIST = "resources/stopwordOveB.txt";
//	public final static String STOP_WORD_LIST = "resources/documents/misc/TERMFREQUENCY.txt";
//	public final static String STOP_WORD_LIST = "resources/stopwordsNO";
	
	public final static String TEST_DOCUMENT_PATH = "resources/sample document";
	public final static String TAGGED_TEST_DOCUMENTS_PATH = "resources/sample document/tagged";
	public final static String TAGGED_DOCUMENTS_PATH = "resources/documents/tagged";
	public final static String TOKENIZED_KEYWORDS_PATH = "resources/documents/tokenizedKeywords";
	public final static String CLASSIFIER_PATH = "resources/documents/classifier";
	public final static String WEKA_CLASSIFIER_PATH = "resources/documents/wekaClassifier";
	public final static String TEXTRANK_TOKENIZED_KEYWORDS_PATH = "resources/documents/textRankTokenizedKeywords";
	
//	public final static String TEXTRANK_CLASSIFIER_PATH = "resources/adressa/textRank";
	public final static String TEXTRANK_CLASSIFIER_PATH = "resources/documents/textRankClassifier";

	public final static String TESTDOC_CLASSIFIER_PATH = "resources/documents/testDocsClassifier";
	public final static String TESTDOC_TEXTRANKCLASSIFIER_PATH = "resources/documents/textRankTestClassifier";
	public final static String TESTDOC_WEKACLASSIFIER_PATH = "resources/documents/wekaTestClassifier";
	
	public final static String ADRESSA_DOCUMENT_PATH = "resources/adressa";
	public final static String ADRESSA_CLASSIFIER_PATH = "resources/adressaClassifier";
	
	public final static String EVALUATION_DOCS_PATH = "resources/adressa/evaluationDocuments";

	public final static String LOGFILE = "C:\\Users\\Kristian\\Desktop\\Master\\logs\\";


	public final static int MIN_KEYWORD_WORDCOUNT = 1;
	public final static int MAX_KEYWORD_WORDCOUNT = 4;

	public static long time = 0;
	public static long localTimeUsed = 0;
	public static long remoteTimeUsed = 0;

	public static boolean removeProperNouns = true;
	public static boolean includeStopwordTrigrams = true;

	public static boolean weighted = true;
	public static boolean lowWeight = false;
	public static boolean useRatio = true;

	public static boolean onlyEndOfSentenceNoun = false;
	public static boolean onlyNounPhrases = true;

	public static boolean doClustering = true;
	public static boolean removeLowerRanked = false;
	
	public static boolean stemming = true;
	public static boolean preStemming = false;
	

//	public static void setOptions(boolean removeProperNouns, boolean includeStopwordTrigrams, boolean weighted, boolean lowWeight, boolean useRatio, 
//			boolean onlyEndOfSentenceNoun, boolean onlyNounPhrases, boolean doClustering, boolean removeLowerRanked){
//		GlobalParameters.removeProperNouns = removeProperNouns;
//		GlobalParameters.includeStopwordTrigrams = includeStopwordTrigrams;
//		GlobalParameters.weighted = weighted;
//		GlobalParameters.lowWeight = lowWeight;
//		GlobalParameters.useRatio = useRatio;
//		GlobalParameters.onlyEndOfSentenceNoun = onlyEndOfSentenceNoun;
//		GlobalParameters.onlyNounPhrases = onlyNounPhrases;
//		GlobalParameters.doClustering = doClustering;
//		GlobalParameters.removeLowerRanked = removeLowerRanked;
//	}

	public static void setOptions(boolean[] parameters){
		GlobalParameters.removeProperNouns = parameters[0];
		GlobalParameters.includeStopwordTrigrams = parameters[1];
		GlobalParameters.weighted = parameters[2];
		GlobalParameters.lowWeight = parameters[3];
		GlobalParameters.useRatio = parameters[4];
		GlobalParameters.onlyEndOfSentenceNoun = parameters[5];
		GlobalParameters.onlyNounPhrases = parameters[6];
		GlobalParameters.doClustering = parameters[7];
		GlobalParameters.removeLowerRanked = parameters[8];
		GlobalParameters.stemming = parameters[9];
		GlobalParameters.preStemming = parameters[10];
	}
	
	public static void setOptions(List<Boolean> parameters){
		
//		GlobalParameters.includeStopwordTrigrams = parameters.get(0);
		GlobalParameters.weighted = parameters.get(0);
		GlobalParameters.lowWeight = parameters.get(1);
		GlobalParameters.useRatio = parameters.get(2);
//		GlobalParameters.onlyEndOfSentenceNoun = parameters.get(3);
		GlobalParameters.onlyNounPhrases = parameters.get(3);
//		GlobalParameters.doClustering = parameters.get(6);
//		GlobalParameters.removeLowerRanked = parameters.get(7);
		GlobalParameters.stemming = parameters.get(4);
		GlobalParameters.removeProperNouns = parameters.get(5);
//		GlobalParameters.preStemming = parameters.get(9);
	}
	
	public static void printOptions(){
		System.out.println("GLOBALOPTIONS FOR WRAKE");
		System.out.println("RemoveProperNouns: " + removeProperNouns);
		System.out.println("IncludeStopwordTrigrams: " + includeStopwordTrigrams);
		System.out.println("Weighted: " + weighted);
		System.out.println("lowWeigth: " + lowWeight);
		System.out.println("useRatio: " + useRatio);
		System.out.println("OnlyEndOfSentenceNoun: " + onlyEndOfSentenceNoun);
		System.out.println("OnlyNounPhrases: " + onlyNounPhrases);
		System.out.println("DoClustering: " + doClustering);
		System.out.println("RemoveLowerRanked: " + removeLowerRanked);
		System.out.println("Stemming: " + stemming);
		System.out.println("PreStemming: " + preStemming);
	}

}
