package htmlParsing.impl;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

import htmlParsing.Document;
import htmlParsing.DocumentExtractor;
import htmlParsing.DocumentTerm;

public class DocumentExtractorImpl implements DocumentExtractor{


	@Override
	public ArrayList<Document> extract(File file) throws FileNotFoundException {
		ArrayList<Document> collection = new ArrayList<Document>();

		Scanner scanner = new Scanner(file);
		int i = 1;
		try{
			while (scanner.hasNext()){
				
				Document d = new DocumentImpl();
				String aLine = scanner.nextLine();
				String[] attributes = doubleSplit(aLine, "http:", "<vector>");
				
								
				d.setHashCode(attributes[0]);
				d.setUrlPath("http:" + attributes[1]);
				d.setVectorString("<vector>" + attributes[2]);
				d.setDocumentTerms(extractTerms("<vector>" + attributes[2]));
				
				collection.add(d);
			
				i++;
			}
		}
		finally{
			scanner.close();
		}
		return collection;
	}

	private String[] doubleSplit(String line, String exp, String otherExp){
		String[] temp = line.split(exp, 2);
		String[] temp2 = temp[1].split(otherExp, 2);
		String[] doubleSplit = new String[3];
		doubleSplit[0]=temp[0];
		doubleSplit[1]=temp2[0];
		doubleSplit[2]=temp2[1]; 
		return doubleSplit;
	}
	
	private ArrayList<DocumentTerm> extractTerms(String vector){
		vector = vector.replaceAll("<vector>", "");
		vector = vector.replaceAll("</vector>", "");
		
		ArrayList<DocumentTerm> documentTerms = new ArrayList<DocumentTerm>();
		String[] data = vector.split("<data>");
		String term;
		String weightString;
		
		for(String s: data){
			if(s.isEmpty()){
				continue;
			}
			term = getBetweenString(s, "string");
			weightString = getBetweenString(s, "weight");
			double weight = Double.valueOf(weightString);
			DocumentTerm dTerm = new DocumentTermImpl(term, weight, 1, false);
			documentTerms.add(dTerm);
		}
		return documentTerms;	
	}

	public String getBetweenString(String string, String type){
		int start = string.indexOf("<" + type + ">");
		int end = string.indexOf("</" + type + ">");
		int typeLength = type.length();
		return string.substring(start+typeLength+2, end);
	}

}
