package htmlParsing.impl;

import java.net.URL;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import javax.swing.text.html.parser.TagElement;

import net.htmlparser.jericho.*;

public class HtmlPageStripperReader {


	public static StringBuilder getPageContent(String url){
		String sourceUrlString=url;

		if (sourceUrlString.indexOf(':')==-1) sourceUrlString="file:"+sourceUrlString;
		MicrosoftTagTypes.register();
		PHPTagTypes.register();
		PHPTagTypes.PHP_SHORT.deregister(); // remove PHP short tags for this example otherwise they override processing instructions
		MasonTagTypes.register();
		Source source = null;
		try{
			source=new Source(new URL(sourceUrlString));
			
					
		}
		catch(Exception e){
			
		}
		String title = "";
		StringBuilder s;
//		StringBuilder headerString;
		try{
			title = getTitle(source);
			title.replaceAll("<br>", "");
			s = new StringBuilder(source.getParseText().toString());
			s = ostleningenFilter(sourceUrlString, s);
			if(s.toString().isEmpty()){
				return new StringBuilder("");
			}
//			headerString = ostleningenHeaderFilter(s);
			source = new Source(s.subSequence(0, s.length()-1));
			
		}
		catch(NullPointerException e){
			return new StringBuilder("");
		}
		
		final Set<String> includeAttributeNames=new HashSet<String>(Arrays.asList(new String[] {}));
		TextExtractor textExtractor=new TextExtractor(source) {
		    public boolean excludeElement(StartTag startTag) {
		        return "articlemeta".equalsIgnoreCase(startTag.getAttributeValue("class"));
		    }
		    public boolean includeAttribute(StartTag startTag, Attribute attribute) {
		        return includeAttributeNames.contains(attribute.getKey());
		    }
		};
		
		textExtractor.includeTag("br");
		textExtractor.includeTag("p");
		textExtractor.includeTag("strong");
		
		
//		System.out.println(textExtractor.setIncludeAttributes(false).toString());	
		String returnString = "*TITLE*" + title + "*/TITLE*" + "\n" + textExtractor.setIncludeAttributes(true).toString();
		
		return new StringBuilder(returnString);
	}
	
	public boolean excludeElement(StartTag startTag) {
        return "NotIndexed".equalsIgnoreCase(startTag.getAttributeValue("class"));
    }
	
	public static StringBuilder ostleningenHeaderFilter(final StringBuilder content){
		final int startLength = "<strong>".length();
		int start = content.indexOf("<strong>");
		if (start <= 0)
//			start = 0;
			return new StringBuilder("");
		else
			start += startLength;
		int end = content.indexOf("</strong>");
		if (start > 0 && end > 0 && start < end)
			return new StringBuilder("<HEADER>" + content.substring(start, end) + "</HEADER>");
		return new StringBuilder("");
	}

	public static StringBuilder ostleningenFilter(final String url, final StringBuilder
			content) {
		final int startLength = "<div class=\"article\">".length();
		int start = content.indexOf("<div class=\"article\">");
		if (start <= 0)
//			start = 0;
			return new StringBuilder("");
		else
			start += startLength;
		int end = content.lastIndexOf("<div class=\"articleXtras\">");
//		if (end < 0)
//			end = content.length();
		//			        if (Logger.DEBUG_ENABLED)
		//			            LOG.debug(HtmlRawPageFilter.class, "slendingen: [" + start + ", " + end +
		//			"]{" + url + "}");
		if (start > 0 && end > 0 && start < end)
			return new StringBuilder(content.substring(start, end));
		return content;
	}
	
	private static String getTitle(Source source) {
		Element titleElement = null;
		try{
			titleElement=source.getFirstElement(HTMLElementName.TITLE);
			
		}
		catch(NullPointerException e){
			return null;
		}
		
		// TITLE element never contains other tags so just decode it collapsing whitespace:
		String s = "";
		try{
			s =CharacterReference.decodeCollapseWhiteSpace(titleElement.getContent());
		}
		catch(NullPointerException e){
			return null;
		}
		return s;
	}

	
	public static void main(String[] args){
		;
		System.out.println(getPageContent("http://www.ostlendingen.no/nyheter/gir-opp-tvinnlandet-1.4020497"));
		System.out.println(getPageContent("http://www.ostlendingen.no/nyheter/trysil-engerdal/kjemper-for-rovdyr-pa-facebook-1.6011902?ssoAction=password_sent&cellNumberx=90574894#commentform"));
	}
}
