package htmlParsing.impl;

import global.GlobalParameters;
import htmlParsing.impl.DocumentExtractorImpl;
import htmlParsing.Document;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

import htmlParsing.impl.HtmlPageStripperReader;
import taggerAndWordbank.impl.OsloBergenTagger;
import util.HtmlTagHelper;
import util.StringHelper;
import util.StringToFile;

public class Main {

	public void singleDocument(String urlPath){
		OsloBergenTagger obt;
		StringBuilder htmlStrippedSB;
		try{
			obt= new OsloBergenTagger();
		}
		catch(Exception e){

		}
		System.out.println("URL is: " + urlPath);
		String mambo = HtmlPageStripperReader.getPageContent(urlPath).toString();
		//				String returnString = HtmlPageStripperReader.getPageContent("http://www.ostlendingen.no/nyheter/gir-opp-tvinnlandet-1.4020497").toString();
		if(!mambo.trim().isEmpty()){
			System.out.println("PREFORMAT" + mambo);
			String returnString = HtmlTagHelper.formatTextWithHtmlTags(mambo);
			returnString = StringHelper.removeByline(returnString);
			returnString = StringHelper.removeWhiteSpace(returnString);
			returnString = StringHelper.preColonWordsToLowerCase(returnString);
			returnString = returnString.replaceAll(":", ".");
			returnString = StringHelper.removeRandomQuestionMarks(returnString);
			System.out.println("START" + returnString);
			System.out.println(returnString.charAt(1315));
			String[] fileStringArray = HtmlTagHelper.contentToArray(returnString);
			try {
				obt= new OsloBergenTagger();

				for(int j=0;j<3;j++){
					System.out.println(fileStringArray[j]);
					try{
						htmlStrippedSB = new StringBuilder(fileStringArray[j]);
					}
					catch(NullPointerException nullP){
						continue;
					}
					System.out.println("PRETAG " + htmlStrippedSB.toString());
					String[] tags = obt.tag(htmlStrippedSB);
					System.out.println("TAGS");
					String[] terms = obt.getTerms();	
					System.out.println("TERMS");

					fileStringArray[j] ="";
					if (tags != null && terms != null && tags.length == terms.length){
						for (int i = 0; i < tags.length; i++){
							fileStringArray[j] += obt.fixUnknownChars(terms[i]) + "/" + tags[i] + (terms[i].equals(".") ? "\n" : " ");
							System.out.println("JUST TAGGED: " + fileStringArray[j]);
						}
						//							System.out.print(taggedText);
					}				
				}
			}
			catch(Exception e){

			}


			returnString = "*TITLE*" + fileStringArray[0] + "*/TITLE*" + "\n";
			returnString += "*HEADER*" + fileStringArray[1] + "*/HEADER*" + "\n";
			returnString += fileStringArray[2];

			System.out.println("AT END" + returnString);

			StringToFile.writeToFileURL(returnString, urlPath);
		}
	}

	public void allDocuments(){
		OsloBergenTagger obt;
		StringBuilder htmlStrippedSB;
		try{
			obt= new OsloBergenTagger();
		}
		catch(Exception e){

		}
		List<Document> documents = new ArrayList<Document>();
		DocumentExtractorImpl extractor = new DocumentExtractorImpl();


		File dir = new File("resources/test-corpus");
		if(dir.isDirectory()){
			File[] files = dir.listFiles();


			for(File file : files){
				try {
					List<Document> dList = extractor.extract(file);
					documents.addAll(dList);
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				}
			}
			System.out.println("Document size is: " + documents.size());
			for(Document d: documents){
				if(d.getUrlPath().contains("http://www")){
					System.out.println("URL is: " + d.getUrlPath());
					StringBuilder sb = HtmlPageStripperReader.getPageContent(d.getUrlPath());

					for(int i=0;i<sb.length();i++){
						char ch=sb.charAt(i);
						if(Character.getNumericValue(ch)==-1 && Character.getType(ch)==15){
							sb.replace(i, i+1, "");
						}
					}
					String returnString = sb.toString();
					//				String returnString = HtmlPageStripperReader.getPageContent("http://www.ostlendingen.no/nyheter/gir-opp-tvinnlandet-1.4020497").toString();
					if(!returnString.trim().isEmpty()){
						//					System.out.println("PREFORMAT" + returnString);
						String[] fileStringArray = StringHelper.formatOperations(returnString);
						try {
							obt= new OsloBergenTagger();

							for(int j=0;j<3;j++){
								try{
									htmlStrippedSB = new StringBuilder(fileStringArray[j]);
								}
								catch(NullPointerException nullP){
									continue;
								}
								String[] tags = obt.tag(htmlStrippedSB);
								String[] terms = obt.getTerms();					

								fileStringArray[j] ="";
								if (tags != null && terms != null && tags.length == terms.length){
									for (int i = 0; i < tags.length; i++){
										fileStringArray[j] += obt.fixUnknownChars(terms[i]) + "/" + tags[i] + (terms[i].equals(".") ? "\n" : " ");
									}
									//							System.out.print(taggedText);
								}				
							}
						}
						catch(Exception e){

						}


						returnString = "*TITLE*" + fileStringArray[0] + "*/TITLE*" + "\n";
						returnString += "*HEADER*" + fileStringArray[1] + "*/HEADER*" + "\n";
						returnString += fileStringArray[2];

						//					System.out.println("AT END" + returnString);

						StringToFile.writeToFileURL(returnString, d.getUrlPath());
						
						double localTimePercent = GlobalParameters.localTimeUsed/(GlobalParameters.localTimeUsed+GlobalParameters.remoteTimeUsed);
						double remoteTimePercent = GlobalParameters.remoteTimeUsed/(GlobalParameters.localTimeUsed+GlobalParameters.remoteTimeUsed);
						System.out.println("PERCENT OF TIME USED LOCAL: " + localTimePercent*100 +"%");
						System.out.println("PERCENT OF TIME USED REMOTE: " + remoteTimePercent*100 +"%");
					}
				}
				
			}
		}
		System.out.println(documents.size());
	}

	public static String[] formatOperations(String str){
		String returnString = HtmlTagHelper.formatTextWithHtmlTags(str);
		returnString = StringHelper.removeByline(returnString);
		returnString = StringHelper.removeWhiteSpace(returnString);
		returnString = StringHelper.preColonWordsToLowerCase(returnString);
		returnString = returnString.replaceAll(":", ".");
		returnString = StringHelper.removeRandomQuestionMarks(returnString);
		System.out.println("START" + returnString);
		System.out.println(returnString.charAt(1315));
		String[] fileStringArray = HtmlTagHelper.contentToArray(returnString);
		return fileStringArray;

	}


	public static void main(String[] args) {
		GlobalParameters.time = System.currentTimeMillis();
		Main main=new Main();
		main.allDocuments();
		//		String returnString = "";
		//		String urlPath ="http://www.ostlendingen.no/nyheter/lasskjorerne-overtar-lomviksgarden-1.4598037";
		//		OsloBergenTagger obt;
		//		StringBuilder htmlStrippedSB;
		//		try{
		//			obt= new OsloBergenTagger();
		//		}
		//		catch(Exception e){
		//
		//		}
		//		System.out.println("URL is: " + urlPath);
		//		StringBuilder sb = HtmlPageStripperReader.getPageContent(urlPath);
		//		for(int i=0;i<sb.length();i++){
		//			char ch=sb.charAt(i);
		//			if(Character.getNumericValue(ch)==-1 && Character.getType(ch)==15){
		//				sb.replace(i, i+1, "");
		//			}
		//		}
		//		String sbString = sb.toString();
		//		//				String returnString = HtmlPageStripperReader.getPageContent("http://www.ostlendingen.no/nyheter/gir-opp-tvinnlandet-1.4020497").toString();
		//		if(!sbString.trim().isEmpty()){
		//			System.out.println("PREFORMAT" + sbString);
		//			String[] fileStringArray = StringHelper.formatOperations(sbString);
		//			try {
		//				obt= new OsloBergenTagger();
		//
		//				for(int j=0;j<3;j++){
		//					System.out.println(fileStringArray[j]);
		//					try{
		//						htmlStrippedSB = new StringBuilder(fileStringArray[j]);
		//					}
		//					catch(NullPointerException nullP){
		//						continue;
		//					}
		//					System.out.println("PRETAG " + htmlStrippedSB.toString());
		//					String[] tags = obt.tag(htmlStrippedSB);
		//					System.out.println("TAGS");
		//					String[] terms = obt.getTerms();	
		//					System.out.println("TERMS");
		//
		//					fileStringArray[j] ="";
		//					if (tags != null && terms != null && tags.length == terms.length){
		//						for (int i = 0; i < tags.length; i++){
		//							fileStringArray[j] += obt.fixUnknownChars(terms[i]) + "/" + tags[i] + (terms[i].equals(".") ? "\n" : " ");
		//							System.out.println("JUST TAGGED: " + fileStringArray[j]);
		//						}
		//						//							System.out.print(taggedText);
		//					}				
		//				}
		//			}
		//			catch(Exception e){
		//
		//			}
		//
		//
		//			returnString = "*TITLE*" + fileStringArray[0] + "*/TITLE*" + "\n";
		//			returnString += "*HEADER*" + fileStringArray[1] + "*/HEADER*" + "\n";
		//			returnString += fileStringArray[2];
		//
		//			System.out.println("AT END" + returnString);
		//
		//			StringToFile.writeToFileURL(returnString, urlPath);
		//		}
	}
}
