package keyphraseExtraction.impl;

import java.util.ArrayList;

import keyphraseExtraction.Phrase;

public class PhraseImpl implements Phrase{
	
	private ArrayList<String> phrase;
	private int wordLength;
	private double score;
	private int start;
	private int end;
	
	public PhraseImpl(ArrayList<String> phrase){
		this.phrase=phrase;
		wordLength = phrase.size();
		score = 0.0;
	}
	
	public PhraseImpl(ArrayList<String> phrase, double score){
		this.phrase=phrase;
		wordLength = phrase.size();
		this.score = score;
	}
	
	public PhraseImpl(ArrayList<String> phrase, double score, int start, int end){
		this.end = end;
		this.start = start;
		this.phrase=phrase;
		wordLength = phrase.size();
		this.score = score;
	}

	public ArrayList<String> getPhrase() {
		return phrase;
	}

	public int getWordLength() {
		return wordLength;
	}

	public double getScore() {
		return score;
	}

	public void setScore(double score) {
		this.score = score;
	}
	
	public String getPhraseToString(){
		String phraseString = "";
		for(String s: phrase){
			phraseString += s + " ";
		}
		phraseString = phraseString.trim();
		return phraseString;
	}

	@Override
	public int getEnd() {
		return end;
	}

	@Override
	public int getStart() {
		return start;
	}

	@Override
	public void setEnd(int end) {
		this.end = end;
		
	}

	@Override
	public void setStart(int start) {
		this.start = start;
		
	}

}
