package keyphraseExtraction.impl;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import util.FileReaderHelper;

public class PhrasesWithStopWords {
	
	private List<String> stopWordStrings;
	private List<String> stopWords;
	private final File fFile;
	
	public PhrasesWithStopWords(){
		stopWordStrings = new ArrayList<String>(); 
		stopWords = new ArrayList<String>();
		fFile = new File(keyphraseExtraction.impl.StopwordRemoverImpl.STOP_WORD_LIST_PATH);
		if(!fFile.exists()){
			System.err.println("Cannot find stop word file: "+keyphraseExtraction.impl.StopwordRemoverImpl.STOP_WORD_LIST_PATH);
		}
		stopWords = FileReaderHelper.readFileToStringList(fFile);
	}
	
	public List<String> getStopwordPhrases(String text){
		ArrayList<String> StopWordPhrasesList = new ArrayList<String>();
		String[] words = text.split(" ");
		String temp = "";
		for(int i=1;i<words.length;i++){
			if(stopWords.contains(words[i])){
				temp = words[i-1] + words[i] + words[i+1];
				if(stopWordStrings.contains(temp)){
					StopWordPhrasesList.add(temp);
				}
				else{
					stopWordStrings.add(temp);
				}
			}
		}
		return StopWordPhrasesList;
	}

}
