package keyphraseExtraction.impl;

import global.GlobalParameters;

import java.io.File;

import classifer.impl.Stemmer;

import util.FileReaderHelper;

public class TaggedTextSplitter {

	private Stemmer stemmer ;

	private String[] tagArr;
	private String[] textArr;

	private int offset = 0;

	public TaggedTextSplitter(){

	}

	public TaggedTextSplitter(Stemmer stemmer){
		this.stemmer = stemmer;
	}

	public void split(String text){
		text = text.trim();
		offset = 0;
		//		String text = FileReaderHelper.readFileToString(file);
		String[] taggedTextArr = text.split("\\s+");
		if(taggedTextArr.length==0){
			return;
		}
		tagArr	= new String[taggedTextArr.length];
		textArr = new String[taggedTextArr.length];

		String preWordOfExpression = "";

		for(int i=0;i<taggedTextArr.length;i++){

			try{
				String[] tag = taggedTextArr[i].split("/");
				tagArr[i] = tag[1];
				//				System.out.println(tag[1]);
				if(preWordOfExpression.isEmpty()){
					if(GlobalParameters.removeProperNouns && tag[1].equalsIgnoreCase("NNP")){
						textArr[i] = "-";
						//						System.out.println("TAGGEDTEXTSPLITTER."+tag[0]);
					}
					else{
						if(GlobalParameters.preStemming && GlobalParameters.stemming){
							textArr[i] = stemmer.getBaseForm(tag[0].toLowerCase(), tag[1]);
						}
						else{
							textArr[i] = tag[0].toLowerCase();
						}

					}

					//					System.out.println(tagArr[i] + " " + textArr[i] + " " + i);
				}
				else{
					if(GlobalParameters.removeProperNouns &&  tag[1].equalsIgnoreCase("NNP")){
						textArr[i] = "-";
						//						System.out.println("TAGGEDTEXTSPLITTER."+tag[0]);
					}
					else{
						textArr[i] = preWordOfExpression + tag[0];
					}				
					preWordOfExpression = "";

					//					System.out.println(tagArr[i] + " " + textArr[i]);
					//					System.out.println(tagArr[i-1] + " " + textArr[i-1]);
				}

			}
			catch(ArrayIndexOutOfBoundsException arE){
				//				System.out.println("TAGGEDTEXT: " + taggedTextArr[i]);
				//				arE.printStackTrace();
				preWordOfExpression += taggedTextArr[i] + " ";
				if((i+1)>=tagArr.length){
					System.out.println("OUT OF BOUNDS");
					System.out.println(tagArr.length);
					System.out.println(tagArr[0] + textArr[0]);
					offset++;
				}
				else{
					tagArr[i] = tagArr[i+1]; 
					offset++;
				}

				//				System.out.println(tagArr[i] + " " + textArr[i]);

			}

		}

	}

	public String[] getTagArr() {
		return tagArr;
	}

	public String[] getTextArr() {
		return textArr;
	}

}
