package keyphraseExtraction.impl;

import java.util.ArrayList;
import java.util.List;

import keyphraseExtraction.Candidate;
import keyphraseExtraction.Phrase;

public class TaggerExtractor {
	
	private ArrayList<String> tags = new ArrayList<String>();
	
	public TaggerExtractor(String[] tags){
		for(String s: tags){
			this.tags.add(s);
		}
	}
	
	public TaggerExtractor(){
	}
	
	public void addTags(String[] tags){
		for(String s: tags){
			this.tags.add(s);
		}
	}
	
	public boolean containsNoun(Phrase keywordSentence) {
		int start = keywordSentence.getStart();
		int end = keywordSentence.getEnd();
//		System.out.println(keywordSentence.getPhraseToString() + " " + start + " " + end);
		for(int i=start;i<end;i++){
//			System.out.println(tags.get(i) + " " + i);
			if(tags.get(i)!=null && tags.get(i).equals("NN")){
				return true;
			}
		}
		return false;
	}
	
	public boolean containsNoun(int start, int end){
		for(int i=start;i<end;i++){
			if(tags.get(i)!=null && tags.get(i).equals("NN")){
				return true;
			}
		}
		return false;
	}

	public boolean lastWordIsNoun(Candidate sentence) {
		if(tags.get(sentence.getEnd())=="NN"){
			return true;
		}
		return false;
	}
	
	public boolean lastWordIsNoun(Phrase sentence) {
//		System.out.println("TAGGEREXTRACTOR.isNoun? "+ sentence.getPhraseToString() + " " + tags.get(sentence.getEnd()-1));
		if(tags.get(sentence.getEnd()-1)!=null && tags.get(sentence.getEnd()-1).equalsIgnoreCase("NN")){
//			System.out.println("TAGGEREXTRACTOR.sentence ends with noun: " + sentence.getPhraseToString());
			return true;
		}
		return false;
	}
	
	public String[] getTags(Phrase phrase){
		int start = phrase.getStart();
		int end = phrase.getEnd();
		String[] tagArr = new String[end-start+1];
		int j=0;
		for(int i=start;i<end+1;i++){
			tagArr[j] = tags.get(i);
			j++;
		}
		return tagArr;
	}

}
