package parsers.impl;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


import parsers.Parser;
import taggerAndWordbank.impl.WordbankFilter;
import util.FileReaderHelper;
import util.HtmlTagHelper;
import util.StringHelper;
import util.StringToFile;

public class ProperNamesParser implements Parser{

	private boolean startOfSentence = true;
	private boolean previousWordProperName = false;
	private String properNounTempString = "";
//	private HashSet<String> ProperNamesSet = new HashSet<String>();

	@Override
	public HashSet<String> extractAllWords(File file)
	throws FileNotFoundException {
		HashSet<String> ProperNamesSet = new HashSet<String>();
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String aLine = br.readLine();

			while (aLine != null){
				startOfSentence=true;
				previousWordProperName = false;

				String[] words = aLine.split(" ");
				for(String s: words){
					if(s.isEmpty()){
						continue;
					}
					//					System.out.println(s);

					if(startOfSentence){
						if(s.length()==1 && !Character.isLetterOrDigit(s.charAt(0))){
							continue;
						}
						startOfSentence=false;
						properNounTempString = "";
						previousWordProperName = false;
						s = s.toLowerCase();
						//TODO: naiv implementasjon. Hvis frste ord er en proper noun.
						//TODO: komma
					}
					if(StringHelper.isEndOfSentence(s)){
						startOfSentence=true;
					}	
					if(!Character.isLetterOrDigit(s.charAt(0))){
						s = s.substring(1);					
					}
					if(s.isEmpty()){
						continue;
					}
					if(StringHelper.isUpperCase(s)){
						if(StringHelper.isComma(s.charAt(s.length()-1))){
							properNounTempString += StringHelper.removeEndSymbol(s) + " ";
							previousWordProperName = false;
							ProperNamesSet.add(properNounTempString);
							properNounTempString = "";
						}
						else{
							properNounTempString += StringHelper.removeEndSymbol(s) + " ";
							if(properNounTempString.length()>0) previousWordProperName = true;
						}
						
					}
					else if(previousWordProperName){
						if(StringHelper.isColonOrSemicolon(properNounTempString.charAt(properNounTempString.length()-1))){
//							String[] temp = properNounTempString.split(" ");
//							StringHelper.isCapitalLetters(temp[temp.length-1]);
						}
						else{
							ProperNamesSet.add(properNounTempString);
						}
						
						properNounTempString = "";
						previousWordProperName = false;
					}

				}
				aLine = br.readLine();
			}
			br.close();
		}
		catch (IOException e) {
			System.err.println(e);
		}
		return ProperNamesSet;
	}	

	public static void main(String[] args) {
		WordbankFilter wbFilter = new WordbankFilter();
		ProperNamesParser parser = new ProperNamesParser();
		File dir = new File("resources/documents");
		HashSet<String> theset;
		HashMap<String, String> properNames = new HashMap<String, String>();
		String fileName;
		String output="";
		BufferedWriter out = null;
		try {
		out = new BufferedWriter(new FileWriter("resources\\documents\\" + "misc\\PROPERNAMES" + ".txt"));
		}
		catch (IOException e)
		{
			
			System.out.println("Exception ");
			e.printStackTrace();
		}
		if(dir.isDirectory()){
			File[] files = dir.listFiles();

			for(File file : files){
				if(file.isDirectory()){
					continue;
				}
				try{
					
					fileName = file.getName();
					theset = new HashSet<String>();
					theset = parser.extractAllWords(file);
					for(String s: theset){
						if(!wbFilter.isInList(s.toLowerCase().trim()) && s.split(" ").length<=4){
							if(!s.isEmpty() && !properNames.containsKey(s)){
//								System.out.println("word " + s);
								if(!StringHelper.containsBrackets(s)){
									s=StringHelper.cleanString(s);
									if(StringHelper.isNorwegianLetter(s.substring(0,1))){
//										output += s + "=" + fileName + "\n";
										try {
											s = s + "=" + fileName + "\n";
											s = s.replaceAll("\n", System.getProperty("line.separator"));

											out.write(s);
											

										}
										catch (IOException e)
										{
											
											System.out.println("Exception ");
											e.printStackTrace();
										}
//										properNames.put(s, new StringBuilder(fileName).toString());
//										List<String> values = new ArrayList<String>(properNames.values());
//										System.out.println("NEXT");
//										Iterator<String> valueIterator = values.iterator();
//										while(valueIterator.hasNext()){
//											System.out.println(valueIterator.next());
//										}
//										System.out.println(fileName);
									}
								}
								
							}
							
						}
					}
				}
				catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		
//		String output = "";
//		List<String> entries = new ArrayList<String>(properNames.keySet());
//		List<String> values = new ArrayList<String>(properNames.values());
//		Iterator<String> iterator = entries.iterator();
//		Iterator<String> valueIterator = values.iterator();
//		while(iterator.hasNext()){
//			String s = iterator.next();
//			output += s + "=" +valueIterator.next() + "\n";
////			output += (Map.Entry)iterator.next() + "\n";
//		}
//		for(String s: ProperNames){
//			output += s + "\n";
//		}
//		StringToFile.writeToFile(output, "misc\\PROPERNAMES");
		try{
			out.close();
		}catch(IOException e){
			System.out.println("Failed closing");
		}
		
	}
}
