package parsers.impl;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;

import parsers.Parser;

public class StopWordParser implements Parser{
	
	private final String fileName = "stopwordsNO";
	private HashMap<String, Integer> stopWordMap;

	@Override
	public HashSet<String> extractAllWords(File file)
			throws FileNotFoundException {
		
		stopWordMap = new HashMap<String, Integer>();
		
		if(file == null){
			file = new File(RESOURCE_PATH+fileName);
		}
		if(!file.exists()){
			System.err.println("Cannot find stop word file: "+RESOURCE_PATH+fileName);
		}

		try{
			processLineByLine(file);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
		return null;
	}
	
	

	public final void processLineByLine(File file) throws FileNotFoundException {
		Scanner scanner = new Scanner(file);
		try {
			//first use a Scanner to get each line
			while ( scanner.hasNextLine() ){
				processLine( scanner.nextLine() );
			}
		}
		finally {
			//ensure the underlying stream is always closed
			scanner.close();
		}
	}

	protected void processLine(String aLine){
		//use a second Scanner to parse the content of each line 
		Scanner scanner = new Scanner(aLine);
		while ( scanner.hasNext() ){
			String key = scanner.next();
			stopWordMap.put(key, 1);
		}

		//(no need for finally here, since String is source)
		scanner.close();
	}
}
