package parsers.impl;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.HashSet;
import java.util.Scanner;

import parsers.Parser;

public class WordbankFromSerializedParser implements Parser{

	//	private final String fullFormPath = "C:\\Kristian\\skole\\ordbank_bm";
	private final String serializedAllWordsName = "wbAllWords.ser";
	private final String serializedNounWordsName = "wbNounWords.ser";

	public HashSet<String> extractAllWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedAllWordsName);
		}
		HashSet<String> collection = new HashSet<String>();
//
//		String aLine;
//		String[] aLineTable;

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedAllWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashSet<String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}

//		try {
//			FileReader fr = new FileReader(file);
//			BufferedReader br = new BufferedReader(fr);
//			int cnt = 0;
//			aLine = br.readLine();
//			while (aLine != null){
//				aLine = aLine.replaceAll("\\s+", " "); // Replace multiple whitespaces with one whitespace				
//				aLineTable = aLine.split(" ");
//				collection.add(aLineTable[2]);	
//				cnt++;
//			}
//			br.close();
//			System.out.println(cnt);
//		}
//		catch (IOException e) {
//			System.err.println(e);
//		}
		return collection;

	}

	public HashSet<String> extractNounWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedNounWordsName);
		}
		HashSet<String> collection = new HashSet<String>();

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedNounWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashSet<String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}
		return collection;

	}
}

