package parsers.impl;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.HashSet;

import parsers.Parser;
import unused.ExtractText;

public class WordbankParserToSerialized implements Parser, Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//	private final String fullFormPath = "C:\\Kristian\\skole\\ordbank_bm";
	private final String fileName = "fullform_bm.txt";

	public HashSet<String> extractAllWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+fileName);
		}
		HashSet<String> collection = new HashSet<String>();

		String aLine;
		String[] aLineTable;		

		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			int cnt = 0;
			aLine = br.readLine();
			while (aLine != null){
				aLine = aLine.replaceAll("\\s+", " "); // Replace multiple whitespaces with one whitespace				
				aLineTable = aLine.split(" ");
				collection.add(aLineTable[2]);	
				cnt++;
				aLine = br.readLine();
			}
			br.close();
			System.out.println(cnt);
		}
		catch (IOException e) {
			System.err.println(e);
		}
		
		FileOutputStream fos = null;
		ObjectOutputStream out = null;
		try
		{
			fos = new FileOutputStream(RESOURCE_PATH+"wbAllWords.ser");
			out = new ObjectOutputStream(fos);
			out.writeObject(collection);
			out.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		
		return null;

	}

	public HashSet<String> extractNounWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+fileName);
		}
		HashSet<String> collection = new HashSet<String>();
		String aLine;
		String[] aLineTable;
		
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			int cnt = 0;
			aLine = br.readLine();
			while (aLine != null){
				aLine = aLine.replaceAll("\\s+", " "); // Replace multiple whitespaces with one whitespace				
				aLineTable = aLine.split(" ");
				if(aLineTable[3].equals("subst")){
					collection.add(aLineTable[2]);
				}		
				cnt++;
				aLine=br.readLine();
			}
			br.close();
			System.out.println(cnt);
		}
		catch (IOException e) {
			System.err.println(e);
		}
		
		FileOutputStream fos = null;
		ObjectOutputStream out = null;
		try
		{
			fos = new FileOutputStream(RESOURCE_PATH+"wbNounWords.ser");
			out = new ObjectOutputStream(fos);
			out.writeObject(collection);
			out.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		
		return null;

	}
	
	public static void main(String[] args) {
		WordbankParserToSerialized serializer = new WordbankParserToSerialized();
		try{
			serializer.extractNounWords(null);
		}
		catch(FileNotFoundException e){
			e.printStackTrace();
		}
	}
}
