package taggerAndWordbank.impl;

import global.GlobalParameters;

import java.io.File;
import java.io.StringReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.SOAPBodyElement;
import javax.xml.soap.SOAPConnection;
import javax.xml.soap.SOAPConnectionFactory;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;

import org.apache.commons.codec.binary.Base64;
import org.w3c.dom.DOMException;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import util.FileToString;
import util.HtmlTagHelper;
import util.StringToFile;

//import slt.odir.pagereader.HtmlPageStripperReader;

public class OsloBergenTagger {
	//	private List<Language> supportedLanguages = null;
	private String[] terms = null;
	private String[] tags = null;
	private String[] lemmas = null;
	private TagMapper pennTagMapper = new TagMapper();
	// Host of Oslo Bergen Tagger
	private URL HOST = new URL("http://tekstlab.uio.no:8050/cgp-soap");
	private SOAPConnection connection = null;
	// OBT bugs
	private final boolean FIX_XML_BUG = true;
	private final boolean FIX_ENCODING_BUG = true;
	// SOAP message variables
	private final String NIVEAU = "SND";
	private final String LANGUAGE = "nbo";
	// private final String[] FEATURE_FILTER = { "&lt;ordenstall&gt;",
	// "&amp;person", "@TITTEL",
	// "@SUBJ", "SUBST", "ADJ", "VERB", "ADV", "PREP", "INTERJ", "DET", "KVANT",
	// "DET", "DEM",
	// "DET", "POSS", "PRON", "PERS", "PRON", "REFL", "PRON", "INF-MERKE",
	// "SBU", "FORK",
	// "FOREIGN", "UKJENT", "ENT", "FL", "BE", "UB", "MASK", "FEM", "PROP" };
	// private final String[] FEATURE_FILTER = { "SUBST", "ADJ", "VERB", "ADV",
	// "PREP", "INTERJ",
	// "DET", "DEM", "POSS", "PRON", "PERS", "REFL", "INF-MERKE", "SBU", "FORK",
	// "FOREIGN",
	// "UKJENT", "ENT", "FL", "BE", "UB", "PROP", "KOMP", "KONJ", "PRES", "INF",
	// "CLB",
	// "SYMB", "SP", "PRET", "PERF-PART" };
	private final String[] FEATURE_FILTER = { "SUBST", "ADJ", "VERB", "ADV", "DET", "PRON", "SBU",
			"UKJENT", "PROP", "KONJ", "SYMB", "PREP", "INF-MERKE", "KVANT" };
	private final boolean DISAMBIGUATE = true;
	private final String ENCODING = "UTF-8";
	private final String OUTPUT_FORMAT = "WORD-LEMMA-TAGS-XML";
	// Debugging
	private final boolean PRINT_OUT_MSG = true;
	private final boolean PRINT_IN_MSG = true;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		OsloBergenTagger obt;
		StringBuilder htmlStrippedSB;
		try{
			obt= new OsloBergenTagger();
		}
		catch(Exception e){
			
		}
		File dir = new File("resources/documents");
		if(dir.isDirectory()){
			File[] files = dir.listFiles();
			String[] fileStringArray = new String[3];
			for(File file : files){
				if(file.isDirectory()) continue;
				try{
					fileStringArray = HtmlTagHelper.contentToArray(file);
					System.out.println(file.getName());
				}
				catch(Exception e){

				}
				try {
					obt= new OsloBergenTagger();
					// StringBuilder txt = new StringBuilder("æ ø å Æ Ø Å é É");
					//			String url = "http://www.ostlendingen.no/nyheter/gir-opp-tvinnlandet-1.4020497";
					//			StringBuilder txt = HtmlPageStripperReader.getPageContent(url);
					
					String taggedText = "";
					for(int j=0;j<3;j++){
						try{
						htmlStrippedSB = new StringBuilder(fileStringArray[j]);
						}
						catch(NullPointerException nullP){
							continue;
						}
						String[] tags = obt.tag(htmlStrippedSB);
						String[] terms = obt.getTerms();

						if (tags != null && terms != null && tags.length == terms.length){
							for (int i = 0; i < tags.length; i++){
								;
								taggedText += obt.fixUnknownChars(terms[i]) + "/" + tags[i] + (terms[i].equals(".") ? "\n" : " ");
							}
//							System.out.print(taggedText);
						}				
					}
					if(!taggedText.trim().isEmpty()){
						StringToFile.writeTaggedStringToFile(taggedText, "tagged\\"+file.getName());
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}

	public OsloBergenTagger() throws Exception {
		//		supportedLanguages = new Vector<Language>();
		//		supportedLanguages.add(Language.Norwegian);
	}
	
	public String fixUnknownChars(String word){
		String term = word;
		term=term.replaceAll("Øs", "s");
		term=term.replaceAll("ø", "");
		term=term.replaceAll("å", "");
		term=term.replaceAll("æ", "");
		term=term.replaceAll("–", "-");
		return term;
	}
	//
	//	@Override
	//	public boolean isLanguageSupported(Language language) {
	//		return supportedLanguages.contains(language);
	//	}
	//
	//	@Override
	//	public List<Language> getSupportedLanguages() {
	//		return supportedLanguages;
	//	}


	public String[] tag(StringBuilder text) {
		try {
			// first create the connection if necessary
			if (connection == null)
				createSoapConnection();
			SOAPMessage outMsg = constructSoapMsg(text.toString());
			if (PRINT_OUT_MSG)
				printMsg(outMsg);
			GlobalParameters.localTimeUsed += System.currentTimeMillis() -GlobalParameters.time;
			GlobalParameters.time = System.currentTimeMillis();
			SOAPMessage inMsg = submitSoapMsg(outMsg);
			GlobalParameters.remoteTimeUsed += System.currentTimeMillis() -GlobalParameters.time;
			GlobalParameters.time = System.currentTimeMillis();
			if (PRINT_IN_MSG)
				printMsg(inMsg);
			String taggedTextAsXml = soapMsg2Str(inMsg);
			parseXml(taggedTextAsXml);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return tags;
	} // tag


	public String[] getTerms() {
		return terms;
	} // getTerms


	public String[] getTags() {
		return tags;
	} // getTags

	public String[] getLemmas() {
		return lemmas;
	} // getLemmas

	/**
	 * @param xml
	 *            the XML containing the terms, tags, and lemmas.
	 */
	private void parseXml(String xml) {
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			SAXParser saxParser = factory.newSAXParser();
			SAXEventHandler eh = new SAXEventHandler();
			saxParser.parse(new InputSource(new StringReader(xml)), eh);
			terms = eh.getTerms();
			lemmas = eh.getLemmas();
			tags = eh.getTags();
			for (int i = 0; i < terms.length; i++) {
				tags[i] = pennTagMapper.map2PennTreebank((tags[i].length() == 0 ? lemmas[i]
				                                                                         : tags[i]));
				// String tag = pennTagMapper.map2PennTreebank((tags[i].length()
				// == 0 ? lemmas[i]
				// : tags[i]));
				// if (tag == null) {
				// tag = tags[i];
				// System.out.println(terms[i] + "/" + tag + "::" + lemmas[i]);
				// }
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	} // parseXml

	private String soapMsg2Str(SOAPMessage msg) throws DOMException, SOAPException {
		if (msg != null) {
			String base64content = msg.getSOAPBody().getChildNodes().item(0).getFirstChild()
			.getNodeValue();
			if (base64content != null) {
				String soapMsgAsStr = new String(Base64.decodeBase64(base64content.getBytes()));
				if (FIX_XML_BUG) {
					// fix obt xml bug
					soapMsgAsStr = soapMsgAsStr.replaceFirst("<newline/>", "<newline>");
					soapMsgAsStr = soapMsgAsStr.concat("</newline>");
				}
				if (FIX_ENCODING_BUG) {
					// fix obt encoding bugs
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã", "Å");
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã¥", "å");
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã", "Ø");
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã¸", "ø");
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã", "Æ");
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã¦", "æ");
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã©", "é");
					soapMsgAsStr = soapMsgAsStr.replaceAll("Ã", "É");
				}
				return soapMsgAsStr;
			}
		}
		return null;
	} // soapMsg2String

	private void createSoapConnection() throws UnsupportedOperationException, SOAPException {
		SOAPConnectionFactory scf = SOAPConnectionFactory.newInstance();
		connection = scf.createConnection();
	} // createConnection

	/**
	 * Parts of code taken from
	 * http://www.idi.ntnu.no/grupper/if/publikasjoner/MasteroppgaveOesthus.pdf
	 * 
	 * @param text
	 *            the text to tag
	 * @return the create soap message
	 * @throws SOAPException
	 *             thrown in case of an error
	 */
	private SOAPMessage constructSoapMsg(String text) throws SOAPException {
		// Create a message factory and create a message from the message
		// factory.
		SOAPMessage msg = MessageFactory.newInstance().createMessage();
		MimeHeaders hd = msg.getMimeHeaders();
		hd.addHeader("SOAPAction", "ACLSOAP");
		// Message creation takes care of creating the SOAPPart - a
		// required part of the message as per the SOAP 1.1
		// specification.
		SOAPPart sp = msg.getSOAPPart();
		// Retrieve the envelope from the soap part to start building
		// the soap message.
		SOAPEnvelope envelope = sp.getEnvelope();
		// setting encoding style and name-spaces for the envelope
		envelope.setEncodingStyle("http://schemas.xmlsoap.org/soap/encoding/");
		envelope.addNamespaceDeclaration("xsd", "http://www.w3.org/2001/XMLSchema");
		envelope.addNamespaceDeclaration("xsi", "http://www.w3.org/2001/XMLSchema-instance");
		envelope.addNamespaceDeclaration("SOAP-ENC", "http://schemas.xmlsoap.org/soap/encoding");
		// Create a soap body from the envelope.
		SOAPBodyElement body = envelope.getBody().addBodyElement(
				envelope.createName("tagTextBase64", "cgps", "http://www.aksis.uib.no/cgp"));
		SOAPElement language = body.addChildElement(envelope.createName("language"));
		language.setAttribute("xsi:type", "xsd:string");
		language.addTextNode(LANGUAGE);
		SOAPElement niveau = body.addChildElement(envelope.createName("niveau"));
		niveau.setAttribute("xsi:type", "xsd:string");
		niveau.addTextNode(NIVEAU);
		SOAPElement txt = body.addChildElement(envelope.createName("text"));
		txt.setAttribute("xsi:type", "xsd:string");
		txt.addTextNode(text);
		SOAPElement encoding = body.addChildElement(envelope.createName("encoding"));
		encoding.setAttribute("xsi:type", "xsd:string");
		encoding.addTextNode(ENCODING);
		SOAPElement outputFormat = body.addChildElement(envelope.createName("output-format"));
		outputFormat.setAttribute("xsi:type", "xsd:string");
		outputFormat.addTextNode(OUTPUT_FORMAT);
		SOAPElement featureFilter = body.addChildElement(envelope.createName("feature-filter"));
		for (int i = 0; i < FEATURE_FILTER.length; i++) {
			SOAPElement f = featureFilter.addChildElement(envelope.createName("f"));
			f.setAttribute("xsi:type", "xsd:string");
			f.addTextNode(FEATURE_FILTER[i]);
		}
		SOAPElement disambiguate = body.addChildElement(envelope.createName("total-disambiguate"));
		disambiguate.setAttribute("xsi:type", "xsd:boolean");
		disambiguate.addTextNode(String.valueOf(DISAMBIGUATE));
		return msg;
	} // createSoapMsg

	private SOAPMessage submitSoapMsg(SOAPMessage msg) throws SOAPException {
		// Send the message to the provider using the connection.
		return connection.call(msg, HOST);
	} // submitSoapMsg

	private void printMsg(SOAPMessage msg) {
		if (msg != null)
			try {
				System.out.println("--------------------------------------");
				msg.writeTo(System.out);
				System.out.println("\n--------------------------------------");
			} catch (Exception e) {
				e.printStackTrace();
			}
	} // printMsg

	private class SAXEventHandler extends DefaultHandler {
		private ArrayList<String> tags = null;
		private ArrayList<String> lemmas = null;
		private ArrayList<String> terms = null;
		private String currTag = null;
		private String currLemma = null;
		private String currTerm = null;
		private int index = -1;
		private boolean newElem = false;

		/**
		 * @return the tags
		 */
		public String[] getTags() {
			String[] retVal = new String[tags.size()];
			retVal = tags.toArray(retVal);
			return retVal;
		}

		/**
		 * @return the lemmas
		 */
		public String[] getLemmas() {
			String[] retVal = new String[lemmas.size()];
			retVal = lemmas.toArray(retVal);
			return retVal;
		}

		/**
		 * @return the terms
		 */
		public String[] getTerms() {
			String[] retVal = new String[terms.size()];
			retVal = terms.toArray(retVal);
			return retVal;
		}

		@Override
		public void startDocument() throws SAXException {
			tags = new ArrayList<String>();
			lemmas = new ArrayList<String>();
			terms = new ArrayList<String>();
			index = -1;
			newElem = false;
		}

		@Override
		public void startElement(String uri, String localName, String qName, Attributes attributes)
		throws SAXException {
			newElem = false;
			if (qName.equalsIgnoreCase("newline")) {
			} else {
				newElem = true;
				index++;
				for (int i = 0; i < attributes.getLength(); i++)
					if (attributes.getQName(i).equals("lemma"))
						currLemma = attributes.getValue(i);
					else if (attributes.getQName(i).equals("features"))
						currTag = attributes.getValue(i);
			}
		}

		@Override
		public void endElement(String uri, String localName, String qName) throws SAXException {
			if (newElem) {
				tags.add(currTag);
				terms.add(currTerm);
				lemmas.add(currLemma);
				newElem = false;
			}
		}

		@Override
		public void characters(char[] ch, int start, int length) throws SAXException {
			if (newElem) {
				String tmp = new String();
				for (int i = start; i < start + length; i++)
					tmp += ch[i];
				currTerm = tmp;
			}
		}
	} // class SAXEventHandler

	public class TagMapper {
		private HashMap<Integer, String> tagMap = null;

		public TagMapper() {
			tagMap = new HashMap<Integer, String>();
			tagMap.put("konj".hashCode(), "CC");
			tagMap.put("konj clb".hashCode(), "CC");
			tagMap.put("subst".hashCode(), "NN");
			tagMap.put("subst prop".hashCode(), "NNP");
			tagMap.put("prep".hashCode(), "IN");
			tagMap.put("sbu".hashCode(), "IN");
			tagMap.put("pron".hashCode(), "PRP");
			tagMap.put("adj".hashCode(), "JJ");
			tagMap.put("verb".hashCode(), "VB");
			tagMap.put("adv".hashCode(), "RB");
			tagMap.put("det".hashCode(), "DT");
			tagMap.put("inf-merke".hashCode(), "TO");
			tagMap.put("det kvant".hashCode(), "CD");
			//
			// tagMap.put("konj".hashCode(), "CC");
			// tagMap.put("konj clb".hashCode(), "CC");
			// tagMap.put("verb pres".hashCode(), "VB");
			// tagMap.put("verb pret".hashCode(), "VBD");
			// tagMap.put("adv".hashCode(), "RB");
			// tagMap.put("adj komp".hashCode(), "JJR");
			// tagMap.put("prep".hashCode(), "IN");
			// tagMap.put("pron ent pers".hashCode(), "PRP");
			// tagMap.put("subst be ent".hashCode(), "NNP");
			// tagMap.put("subst be fl".hashCode(), "NNPS");
			// tagMap.put("subst ub ent".hashCode(), "NN");
			// tagMap.put("subst ub fl".hashCode(), "NNS");
			// tagMap.put("pron sp".hashCode(), "WP");
			// behold
			tagMap.put("symb".hashCode(), "SYM");
			// tagMap.put("clb".hashCode(), "PU");
			tagMap.put("$-".hashCode(), ":");
			tagMap.put("$:".hashCode(), ":");
			tagMap.put("$.".hashCode(), ".");
			tagMap.put("$,".hashCode(), ",");
			tagMap.put("$(".hashCode(), "-LRB-");
			tagMap.put("$)".hashCode(), "-RRB-");
			tagMap.put("ukjent".hashCode(), "UKN");
		}

		public String map2PennTreebank(String tag) {
			String mappedTag = tagMap.get(tag.hashCode());
			if (mappedTag == null) {
				if (tag.startsWith("subst prop"))
					mappedTag = "NNP";
			}
			return mappedTag;
		} // map2PennTreebank
	} // class TagMapper
}
