package taggerAndWordbank.impl;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.HashMap;
import java.util.HashSet;

import parsers.Parser;

public class WordbankFromSerializedParser implements Parser{

	//	private final String fullFormPath = "C:\\Kristian\\skole\\ordbank_bm";
	private final String serializedAllWordsName = "wbAllWords.ser";
	private final String serializedNounWordsName = "wbNounWords.ser";
	private final String serializedVerbWordsName = "wbVerbWords.ser";
	private final String serializedAdjectiveWordsName = "wbAdjWords.ser";

	@SuppressWarnings("unchecked")
	public HashSet<String> extractAllWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedAllWordsName);
		}
		HashSet<String> collection = new HashSet<String>();
//
//		String aLine;
//		String[] aLineTable;

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedAllWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashSet<String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}

//		try {
//			FileReader fr = new FileReader(file);
//			BufferedReader br = new BufferedReader(fr);
//			int cnt = 0;
//			aLine = br.readLine();
//			while (aLine != null){
//				aLine = aLine.replaceAll("\\s+", " "); // Replace multiple whitespaces with one whitespace				
//				aLineTable = aLine.split(" ");
//				collection.add(aLineTable[2]);	
//				cnt++;
//			}
//			br.close();
//			System.out.println(cnt);
//		}
//		catch (IOException e) {
//			System.err.println(e);
//		}
		return collection;

	}

	@SuppressWarnings("unchecked")
	public HashMap<String, String> extractNounWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedNounWordsName);
		}
		HashMap<String, String> collection = new HashMap<String, String>();

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedNounWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashMap<String, String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}
		return collection;

	}
	
	@SuppressWarnings("unchecked")
	public HashMap<String, String> extractNounMap(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedNounWordsName);
		}
		HashMap<String, String> collection = new HashMap<String, String>();

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedNounWordsName);
			in = new ObjectInputStream(fis);
			Object o = in.readObject();
//			System.out.println("WordbankFromSerialized." + o.toString());
//			System.out.println("WordbankFromSerialized." + o);
			collection = (HashMap<String, String>)o;
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}
		return collection;

	}
	
	@SuppressWarnings("unchecked")
	public HashSet<String> extractVerbWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedNounWordsName);
		}
		HashSet<String> collection = new HashSet<String>();

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedVerbWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashSet<String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}
		return collection;

	}
	
	@SuppressWarnings("unchecked")
	public HashMap<String, String> extractVerbMap(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedNounWordsName);
		}
		HashMap<String, String> collection = new HashMap<String, String>();

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedVerbWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashMap<String, String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}
		return collection;

	}
	
	@SuppressWarnings("unchecked")
	public HashSet<String> extractAdjectiveWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedNounWordsName);
		}
		HashSet<String> collection = new HashSet<String>();

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedAdjectiveWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashSet<String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}
		return collection;

	}
	
	@SuppressWarnings("unchecked")
	public HashMap<String, String> extractAdjectiveMap(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+serializedNounWordsName);
		}
		HashMap<String, String> collection = new HashMap<String, String>();

		FileInputStream fis = null;
		ObjectInputStream in = null;
		try
		{
			fis = new FileInputStream(RESOURCE_PATH+serializedAdjectiveWordsName);
			in = new ObjectInputStream(fis);
			collection = (HashMap<String, String>)in.readObject();
			in.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}
		catch(ClassNotFoundException e){
			e.printStackTrace();
		}
		return collection;

	}
}

