package taggerAndWordbank.impl;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.HashMap;
import java.util.HashSet;

import parsers.Parser;

public class WordbankParserToHashMap implements Parser, Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//	private final String fullFormPath = "C:\\Kristian\\skole\\ordbank_bm";
	private final String fileName = "fullform_bm.txt";

	public void extractNounWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+fileName);
		}
		HashMap<String, String> collection = new HashMap<String, String>();
		String aLine;
		String[] aLineTable;

		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			int cnt = 0;
			aLine = br.readLine();
			while (aLine != null){
				aLine = aLine.replaceAll("\\s+", " "); // Replace multiple whitespaces with one whitespace				
				aLineTable = aLine.split(" ");
				if(aLineTable[3].equals("subst")){
					collection.put(aLineTable[2], aLineTable[1]);
				}		
				cnt++;
				aLine=br.readLine();
			}
			br.close();
			System.out.println("WordBankParserToHashMap." + cnt);
		}
		catch (IOException e) {
			System.err.println(e);
		}

		FileOutputStream fos = null;
		ObjectOutputStream out = null;
		try
		{
			fos = new FileOutputStream(RESOURCE_PATH+"wbNounWords.ser");
			out = new ObjectOutputStream(fos);
			out.writeObject(collection);
			out.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}

	}

	public void extractVerbWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+fileName);
		}
		HashMap<String, String> collection = new HashMap<String, String>();
		String aLine;
		String[] aLineTable;

		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			int cnt = 0;
			aLine = br.readLine();
			while (aLine != null){
				aLine = aLine.replaceAll("\\s+", " "); // Replace multiple whitespaces with one whitespace				
				aLineTable = aLine.split(" ");
				if(aLineTable[3].equals("verb")){
					collection.put(aLineTable[2], aLineTable[1]);
				}		
				cnt++;
				aLine=br.readLine();
			}
			br.close();
			System.out.println("WordBankParserToHashMap." + cnt);
		}
		catch (IOException e) {
			System.err.println(e);
		}

		FileOutputStream fos = null;
		ObjectOutputStream out = null;
		try
		{
			fos = new FileOutputStream(RESOURCE_PATH+"wbVerbWords.ser");
			out = new ObjectOutputStream(fos);
			out.writeObject(collection);
			out.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}

	}

	public void extractAdjectiveWords(File file) throws FileNotFoundException {

		if(file == null){
			file = new File(RESOURCE_PATH+fileName);
		}
		HashMap<String, String> collection = new HashMap<String, String>();
		String aLine;
		String[] aLineTable;

		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			int cnt = 0;
			aLine = br.readLine();
			while (aLine != null){
				aLine = aLine.replaceAll("\\s+", " "); // Replace multiple whitespaces with one whitespace				
				aLineTable = aLine.split(" ");
				if(aLineTable[3].equals("adj")){
					collection.put(aLineTable[2], aLineTable[1]);
				}		
				cnt++;
				aLine=br.readLine();
			}
			br.close();
			System.out.println("WordBankParserToHashMap." + cnt);
		}
		catch (IOException e) {
			System.err.println(e);
		}

		FileOutputStream fos = null;
		ObjectOutputStream out = null;
		try
		{
			fos = new FileOutputStream(RESOURCE_PATH+"wbAdjWords.ser");
			out = new ObjectOutputStream(fos);
			out.writeObject(collection);
			out.close();
		}
		catch(IOException ex)
		{
			ex.printStackTrace();
		}

	}

	public static void main(String[] args) {
		WordbankParserToHashMap serializer = new WordbankParserToHashMap();
		try{
			serializer.extractNounWords(null);
			serializer.extractVerbWords(null);
			serializer.extractAdjectiveWords(null);		
		}
		catch(FileNotFoundException e){
			e.printStackTrace();
		}
	}

	@Override
	public HashSet<String> extractAllWords(File file)
			throws FileNotFoundException {
		// TODO Auto-generated method stub
		return null;
	}
}



