package textRank;

import global.GlobalParameters;

import java.io.File;
import java.util.ArrayList;
import java.util.Map.Entry;

import util.FileWriterHelper;

import classifer.impl.PhraseTokenizer;

public class TextRankMain {

	public static void main(String[] args) {
		PhraseTokenizer pt = new PhraseTokenizer();

		File dir = new File(GlobalParameters.EVALUATION_DOCS_PATH);
		String textRankDir = "resources/adressa/textRank";
		if(dir.isDirectory()){
			File[] files = dir.listFiles();

			for(File file : files){
				File[] taggedTexts = file.listFiles();
				if(taggedTexts.length<5){
					continue;
				}
				if(file.isDirectory()){
					File newDir = new File(textRankDir + "/" + file.getName());
					if(!newDir.isDirectory()){
						newDir.mkdir();
					}
					
					for(File text: taggedTexts){
						ArrayList<Entry<String, Double>> keywords = null;
						TextRank tr = new TextRank(text);
						keywords = tr.getKeywordList();
						
						String keywordString = pt.makeTokens(keywords);
						FileWriterHelper.writeFile(textRankDir + "/" + file.getName() + "/" + text.getName(), keywordString);

					}
				} 
			}
		}
	}

}
