package unused;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import util.EntryValueComparator;
import util.FileReaderHelper;
import util.StringHelper;
import util.StringToFile;
import global.GlobalParameters;

public class LocationAndPersonDeterminator {

	private HashMap<String, String[]> entityWordsMap;
	private HashMap<String, String[]> documentProperNounsMap;

	private Set<String> personPrewords;
	private Set<String> locationPrewords;

	private HashMap<String, String[]> persons;
	private HashMap<String, String[]> locations;
	private HashMap<String, String[]> groups;
	private HashMap<String, String[]> unknown;

	public LocationAndPersonDeterminator(){
		personPrewords = new HashSet<String>();
		locationPrewords = new HashSet<String>();

		persons = new HashMap<String, String[]>();
		locations = new HashMap<String, String[]>();
		groups = new HashMap<String, String[]>();
		unknown = new HashMap<String, String[]>();

		personPrewords.add("sier");
		personPrewords.add("iflge");

		locationPrewords.add("i");
	}

	public void determineByPreWord(){
		File entityFile = new File("resources/documents/misc/PROPERNAMES.txt");
		entityWordsMap = FileReaderHelper.readFileToHashMap(entityFile);
		documentProperNounsMap = FileReaderHelper.readFileToReversedHashMap(entityFile);

		System.out.println("list size: " + entityWordsMap.keySet().size());
		int i=0;
		for(String word: entityWordsMap.keySet()){
			i++;
			//			System.out.println("Word nr: " + i + " of " + entityWordsMap.keySet().size());
			List<String> preWordsList = new ArrayList<String>();
			if(entityWordsMap.get(word).length ==0){
				continue;
			}
			for(String s: entityWordsMap.get(word)){
				File file = new File("resources/documents/" + s);
				if(file.isDirectory()){
					continue;
				}
				//				System.out.println("FILENAME:" + file.getName());
				String text = FileReaderHelper.readFileToString(file);
				processPreWords(text, word, s);
				//				preWordsList.addAll(getPreWords(text, word, s));
			}
			//
			//			boolean isPerson = false;
			//			boolean isLocation = false;
			//
			//			for(String preWord: preWordsList){
			//				if(isPerson(preWord)){
			//					System.out.println("Is person: " + word + " in file: ");
			//					isPerson = true;
			//				}
			//				if(isLocation(preWord)){
			//					System.out.println("Is location: " + word + " in file: ");
			//					isLocation = true;
			//				}
			//			}
			//
			//			if(isPerson && isLocation){
			//				groups.put(word, entityWordsMap.get(word));
			//			}
			//			else if(isPerson){
			//				persons.put(word, entityWordsMap.get(word));
			//			}
			//			else if(isLocation){
			//				locations.put(word, entityWordsMap.get(word));
			//			}
			//			else{
			//				unknown.put(word, entityWordsMap.get(word));
			//			}
		}
	}

	public void processPreWords(String text, String word, String fileName){
		List<String> preWordList = new ArrayList<String>();

		int i = 0;
		//		int wordAt;

		String[] textArray = text.split(" ");
		String preWord = "";
		for(String s: textArray){
			if(s.equals(word)){
				if(i>0){
					String fullWord= s;
					boolean person = false;
					boolean location = false;
					preWord = textArray[i-1];
					if(isPerson(preWord)){
						person = true;
					}
					if(isLocation(preWord)){
						location = true;
					}
					int temp=i;
					while(textArray.length>temp+1 && StringHelper.isUpperCase(textArray[temp+1])){
						fullWord += " " + textArray[temp+1];


						if(StringHelper.isEndOfPartSentenceorSentence(textArray[temp+1].trim())){
							fullWord = StringHelper.removeEndSymbol(fullWord.trim());
							break;
						}
						temp++;
					}
					if(person && location){
						if(groups.containsKey(fullWord)){	
							groups.put(fullWord, makeNewArray(groups.get(fullWord), fileName));
						}
						else{
							groups.put(fullWord, toStringArray(fileName));
						}
					}
					else if(person){
						if(persons.containsKey(fullWord)){	
							persons.put(fullWord, makeNewArray(persons.get(fullWord), fileName));
						}
						else{
							persons.put(fullWord, toStringArray(fileName));
						}
					}
					else if(location){
						if(locations.containsKey(fullWord)){	
							locations.put(fullWord, makeNewArray(locations.get(fullWord), fileName));
						}
						else{
							locations.put(fullWord, toStringArray(fileName));
						}
					}
					else{
						if(unknown.containsKey(fullWord)){	
							unknown.put(fullWord, makeNewArray(unknown.get(fullWord), fileName));
						}
						else{
							unknown.put(fullWord, toStringArray(fileName));
						}
					}
				}

			}
			i ++;
		}

	}



	public String[] toStringArray(String word){
		String[] newValueArray = new String[1];
		newValueArray[0] = word;
		return newValueArray;
	}

	public String[] makeNewArray(String[] old, String word){
		//		if(old.length<1){
		//			return toStringArray(word);
		//		}
		String[] newValueArray = new String[old.length+1];
		for(int j=0;j<old.length;j++){
			newValueArray[j]=old[j];
		}
		newValueArray[old.length] = word;
		return newValueArray;
	}

	public boolean isPerson(String preword){
		if(personPrewords.contains(preword)){
			return true;
		}
		return false;
	}

	public boolean isLocation(String preword){
		if(locationPrewords.contains(preword)){
			return true;
		}
		return false;
	}

	public void sysoutFromList(Set<String> list){
		for(String s: list){
			System.out.println(s);
		}
	}

	public String getHashMapEntriesToString(HashMap<String, String[]> map){
		String output = "";
		Iterator<String> iterator = map.keySet().iterator();
		while(iterator.hasNext()){
			String temp = (String)iterator.next(); 
			for(String s: map.get(temp)){
				output += temp + "=" + s + "\n";
			}
		}
		return output;
	}

	public HashSet<String> getFullNameFromText(String fileName, String name){
		HashSet<String> fullNameSet = new HashSet<String>();

		String[] textArray = documentProperNounsMap.get(fileName);

		for(String s: textArray){
			if(s.contains(name)){
				int index = s.indexOf(name);
				while(index>=0){
					char preChar =' ';
					char postChar = ' ';
					if(index>0){
						preChar =s.charAt(index-1);
					}
					if(index + name.length()<s.length()){
						postChar = s.charAt(index + name.length());
					}
					if(Character.isLetterOrDigit(preChar) || Character.isLetterOrDigit(postChar)){

					}
					else{
						fullNameSet.add(s);
					}
					index = s.indexOf(name, index+1);
				}


			}
			//			String[] singleWords = s.split(" ");

		}

		//		String[] textArray = text.split(" ");
		//		if(textArray.length<1) return fullNameSet;
		//		int i=0;
		//		String fullName = name;
		//		for(String s: textArray){
		//			if(s.equals(name)){
		//				int j = i;
		//				while(i>0 && StringHelper.isUpperCase(textArray[i-1])){
		//					fullName = textArray[i-1] + " " + fullName;
		//					i--;
		//				}
		//				while(j<textArray.length-1 && StringHelper.isUpperCase(textArray[j+1])){
		//					fullName = fullName + " " + textArray[j+1];
		//					j++;
		//				}
		//				fullNameSet.add(fullName);
		//			}
		//			i++;
		//		}
		return fullNameSet;
	}

	public String selectFullNameForm(HashSet<String> fullNameSet){
		HashMap<String, Integer> occurenceMap = new HashMap<String, Integer>();
		for(String s: fullNameSet){
			if(occurenceMap.containsKey(s)){
				occurenceMap.put(s, occurenceMap.get(s)+1);
			}
			else{
				occurenceMap.put(s, 1);
			}
		}

		List<String> entries = new ArrayList(occurenceMap.entrySet());
		Collections.sort(entries, new EntryValueComparator());

		Iterator iterator = entries.iterator();
		while (iterator.hasNext()) {
			Entry temp = (Map.Entry)iterator.next();
			String key = (String)temp.getKey();
			int length = key.split(" ").length;
			if(length<2 || length>4){
				continue;
			}
			return key;
		}
		return null;
		//		int max = Collections.max(occurenceMap.values());
		//		for (String word : occurenceMap.keySet() ) { 
		//			if(occurenceMap.get(word).equals(max)){
		//				if(fullName.isEmpty()){
		//					fullName = word;
		//				}
		//				int length = fullName.split(" ").length;
		//				if()
		//			}
	}

	public void outputLocationGroupsAndPersons(){
		String output = "";
		output += "PERSONS" + "\n";
		output += getHashMapEntriesToString(persons);
		output += "LOCATIONS" + "\n";
		output += getHashMapEntriesToString(locations);
		output += "GROUPS" + "\n";
		output += getHashMapEntriesToString(groups);
		output += "UNKNOWN" + "\n";
		output += getHashMapEntriesToString(unknown);

		StringToFile.writeToFile(output, "misc\\LocationsGroupsAndPersons");
	}

	public HashSet<String> findPersons(){
		HashSet<String> allPersons = new HashSet<String>();
		//		String personString = getHashMapEntriesToString(persons);
		//TODO: samle liste for fullnamefromtext i en liste per ord
		Iterator<String> i = persons.keySet().iterator();
		while(i.hasNext()){
			String key = i.next();
			HashSet<String> fullNameSet = new HashSet<String>();
			for(String s: persons.get(key)){
				//				String text = FileReaderHelper.readFileToString(new File(GlobalParamteres.DOCUMENT_PATH + s));
				fullNameSet.addAll(getFullNameFromText(s, key));
			}
			allPersons.add(selectFullNameForm(fullNameSet));
		}
		return allPersons;
	}

	public HashSet<String> findFullForm(HashMap<String, String[]> inputMap){
		HashSet<String> allOccurences = new HashSet<String>();
		Iterator<String> i = inputMap.keySet().iterator();
		while(i.hasNext()){
			String key = i.next();
			HashSet<String> fullNameSet = new HashSet<String>();
			for(String s: inputMap.get(key)){
				//				String text = FileReaderHelper.readFileToString(new File(GlobalParamteres.DOCUMENT_PATH + s));
				fullNameSet.addAll(getFullNameFromText(s, key));
			}
			allOccurences.add(selectFullNameForm(fullNameSet));
		}
		return allOccurences;
	}



	public static void main(String[] args) {
		LocationAndPersonDeterminator det = new LocationAndPersonDeterminator();
		det.determineByPreWord();
		det.outputLocationGroupsAndPersons();

		HashSet<String> persons = det.findPersons();
		HashSet<String> locations = det.findFullForm(det.locations);
		HashSet<String> groups = det.findFullForm(det.groups);

		Iterator i = persons.iterator();
		while(i.hasNext()){
			System.out.println(i.next());
		}
		System.out.println("LOCATIONS");
		Iterator l = locations.iterator();
		while(l.hasNext()){
			System.out.println(l.next());
		}
		System.out.println("GROUPS");
		Iterator g = groups.iterator();
		while(g.hasNext()){
			System.out.println(g.next());
		}

		//		String s= "hei p deg";
		//		String name = "deg";
		//		char preChar=' ';
		//		char postChar= ' ';
		//		if(s.contains(name)){
		//			int index = s.indexOf(name);
		//			preChar =s.charAt(index-1);
		//			if(index + name.length()<s.length()){
		//				postChar = s.charAt(index + name.length());
		//			}
		//			else{
		//
		//			}
		//		}
		//		if(Character.isLetterOrDigit(preChar) || Character.isLetterOrDigit(postChar)){
		//
		//		}
		//		else{
		//			System.out.println("prechar: " + preChar + "postchar: " + postChar);
		//		}


		//		String text ="I morgen er det lrdag i. Da er med od i dog blbllb. I";
		//		String word="Da";
		//		List<String> prewords = det.getPreWords(text, word);
		//		for(String s: prewords){
		//			System.out.println(s);
		//			System.out.println(det.isPerson(s));
		//		}

		//		System.out.println("PERSONS");
		//		det.sysoutFromList(det.persons);
		//		System.out.println("LOCATIONS");
		//		det.sysoutFromList(det.locations);
		//		System.out.println("GROUPS");
		//		det.sysoutFromList(det.groups);
		//		System.out.println("UNKNOWN");
		//		det.sysoutFromList(det.unknown);




	}
}
