//package keyphraseExtraction.impl;
//
//import java.util.ArrayList;
//import java.util.HashMap;
//import java.util.HashSet;
//import java.util.List;
//import java.util.Set;
//import java.util.SortedMap;
//import java.util.TreeMap;
//
//import keyphraseExtraction.Candidate;
//
//import util.StringHelper;
//import global.GlobalParamteres;
//
//public class StopwordRemoverImpl {
//
//	public static final String STOP_WORD_LIST_PATH = "resources\\stopwordsNO";
//	private static final String naiveSplit = "\\s+";
//
//	//Hashmap for stoppord
//	private HashSet<String> stopwordSet;
//	private HashMap<String, Double> occurenceMap;
//	private HashMap<String, Double> degreeMap;
//	private HashMap<String, Double> ratioMap;
//	private List<Candidate> candidateKeywords;
//	private SortedMap<String, Double> keywords;
//	private HashSet<String> stopwordTrigrams;
//	
//	private int offsetIndex;
//	private HashMap<String, Integer> wordPostions;
//	
//	private String candidate = "";
//
//	public StopwordRemoverImpl(HashSet<String> stopwordSet){
//		this.stopwordSet = stopwordSet;
//		occurenceMap = new HashMap<String, Double>();
//		degreeMap = new HashMap<String, Double>();
//		ratioMap = new HashMap<String, Double>();
//		keywords = new TreeMap<String, Double>();
//		stopwordTrigrams = new HashSet<String>();
//		
//		wordPostions = new HashMap<String, Integer>();
//		offsetIndex = 0;
//
//	}
//
//	public void removeStopWords(String text) {		
//		candidateKeywords = new ArrayList<Candidate>();
//		String[] words = prepareString(text);
//
//		int index = 0;
//		int max = words.length;
//		
//		String temp;
//		candidate="";
//		
//		int candidateStart = 0;
//
//		while (index<max){
//			temp = words[index];
//			if(temp.isEmpty()){			
//				index++;
//				continue;
//			}
//			if(candidate.isEmpty()){
//				candidateStart = index;
//			}
//			if(!StringHelper.isNoLetters(temp)){
//				addCandidate(candidateStart, index);			
//				index++;
//				continue;
//			}
//			char last = temp.charAt(temp.length()-1);
//			char first = temp.charAt(0);
//			if(!Character.isLetterOrDigit(first)){
//				temp=temp.substring(1);
//				addCandidate(candidateStart, index);
//			}
//			if (stopwordSet.contains(temp)){
//				addToOccurenceMap(temp);
//				if(index>0){
//					String preword = words[index-1];
//					if(!StringHelper.isEndOfPartSentenceorSentence(preword) && index+1<max){
//						String postword = words[index+1];
//						postword = StringHelper.cleanString(postword);
//						preword = StringHelper.cleanString(preword);
//						String trigram = preword + " " + temp + " " + postword;
//						if(stopwordTrigrams.contains(trigram)){							
//							candidateKeywords.add(new CandidateImpl(trigram,index-1, index+1));
//						}
//						else{
//							stopwordTrigrams.add(trigram);
//						}
//					}				
//				}
//				addCandidate(candidateStart, index);
//			}
//			else if(!Character.isLetterOrDigit(last)){
//				if(temp.length()>1){
//					temp = temp.substring(0, temp.length()-1);
//				}
//				candidate += temp + " ";
//				addToOccurenceMap(temp);
//				addCandidate(candidateStart, index);
//			}							
//			else{
//				candidate += temp + " ";		
//				addToOccurenceMap(temp);	
//			}
//			index++;
//		}
//		offsetIndex = max;
//	}
//	
//	public void removeStopWords(String[] text) {		
//		candidateKeywords = new ArrayList<Candidate>();
//		String[] words = text;
//
//		int index = 0;
//		int max = words.length;
//		
//		String temp;
//		candidate="";
//		
//		int candidateStart = 0;
//
//		while (index<max){
//			try{
//			temp = words[index];
//			if(temp==null || temp.isEmpty()){			
//				index++;
//				continue;
//			}
//			if(candidate.isEmpty()){
//				candidateStart = index;
//			}
//			if(!StringHelper.isNoLetters(temp)){
//				addCandidate(candidateStart, index);			
//				index++;
//				continue;
//			}
//			char last = temp.charAt(temp.length()-1);
//			char first = temp.charAt(0);
//			if(!Character.isLetterOrDigit(first)){
//				temp=temp.substring(1);
//				addCandidate(candidateStart, index);
//			}
//			if (stopwordSet.contains(temp)){
//				addToOccurenceMap(temp);
//				if(index>0){				
//					String preword = words[index-1];					
//					if(!StringHelper.isEndOfPartSentenceorSentence(preword) && index+1<max){
//						String postword = words[index+1];
//						if(StringHelper.isNoLetters(preword) || StringHelper.isNoLetters(postword)){
//							
//						}
//						else{
//							postword = StringHelper.cleanString(postword);
//							preword = StringHelper.cleanString(preword);
//							String trigram = preword + " " + temp + " " + postword;
//							if(stopwordTrigrams.contains(trigram)){							
//								candidateKeywords.add(new CandidateImpl(trigram,index-1, index+1));
//							}
//							else{
//								stopwordTrigrams.add(trigram);
//							}
//						}
//						
//					}				
//				}
//				addCandidate(candidateStart, index);
//			}
//			else if(!Character.isLetterOrDigit(last)){
//				if(temp.length()>1){
//					temp = temp.substring(0, temp.length()-1);
//				}
//				candidate += temp + " ";
//				addToOccurenceMap(temp);
//				addCandidate(candidateStart, index);
//			}							
//			else{
//				candidate += temp + " ";		
//				addToOccurenceMap(temp);	
//			}
//			}
//			catch(NullPointerException e){
//				System.out.println(index);
//				e.printStackTrace();
//			}
//			index++;
//		}
//		offsetIndex += max;
//	}
//
//	public void calculateRatioKeywords(){
//		double candidateValue;
//		for(Candidate c: candidateKeywords){
//			String[] strings =c.getCandidateString().split(" ");
//			candidateValue = 0.0;
//			if(strings.length<GlobalParamteres.MIN_KEYWORD_WORDCOUNT || strings.length>GlobalParamteres.MAX_KEYWORD_WORDCOUNT){
//				continue;
//			}
//			for(String t: strings){
//				if(t.isEmpty()) continue;
//				candidateValue+=ratioMap.get(t);
//			}
//			keywords.put(c.getCandidateString(), candidateValue);
//		}
//	}
//
//
//	public void setRatio(){
//		double freq;
//		double degree;
//		double ratio;
//
//		Set<String> keys = degreeMap.keySet();
//		for(String s: keys){
//			try{
//				freq = occurenceMap.get(s);
//				degree = degreeMap.get(s);
//				ratio = degree/freq;
//				ratioMap.put(s, ratio);
//			}
//			catch(NullPointerException e){
//				System.out.println("NULLPOINTER: " + s);
//			}
//			
//			
//		}
//	}
//
//	public void setWordDegrees(double value){
//		String[] keyword;
//		double length;
//		for(Candidate c: candidateKeywords){
//			keyword = c.getCandidateString().split(" ");
//			length = keyword.length;
//			for(String word: keyword){
//				if(degreeMap.containsKey(word)){
//					degreeMap.put(word, degreeMap.get(word)+length*value); //adds 1 to the number of occurences
//				}
//				else{
//					degreeMap.put(word, length*value); //New occurence
//				}		
//			}
//		}
//	}
//
//	private String[] prepareString(String d) {
//		d = d.replaceAll("\n", " "); // Remove newlines
//		d = d.replaceAll("[ ]{2,}"," "); // Remove multiple spaces
//		d = d.toLowerCase();
//		return d.split(naiveSplit);
//	}
//
//	public SortedMap<String, Double> getKeywords(){
//		return keywords;
//	}
//
////	public HashSet<String> getStopWords(){
////		return stopwordSet;
////	}
//	
//	public void addToOccurenceMap(String temp){
//		if(occurenceMap.containsKey(temp)){
//			occurenceMap.put(temp, occurenceMap.get(temp)+1.0); //adds 1 to the number of occurences
//		}
//		else{
//			occurenceMap.put(temp, 1.0); //New occurence
//		}	
//	}
//	
//	public void addCandidate(int startIndex, int endIndex){
//		if (!candidate.isEmpty()){
//			int start = startIndex+offsetIndex;
//			int end = endIndex+offsetIndex;
//			candidateKeywords.add(new CandidateImpl(candidate, start, end));
//			System.out.println("NEW CANDIDATE: " + candidate + " " + start + " " + end);
//			candidate ="";
//		}
//	}
//	
//	public List<Candidate> getCandidates(){
//		return candidateKeywords;
//	}
//	
//
//}
