package unused;

import global.GlobalParameters;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import keyphraseExtraction.Phrase;
import keyphraseExtraction.impl.StopwordReader;
import keyphraseExtraction.impl.StopwordRemoverImpl;
import keyphraseExtraction.impl.TaggedTextSplitter;
import keyphraseExtraction.impl.TaggerExtractor;
import classifer.impl.PhraseTokenizer;
import classifer.impl.Stemmer;
import clustering.impl.PhraseClustering;

import util.HtmlTagHelper;
import util.PhraseComparator;
import util.StringHelper;

public class Testfile {

	public static void main(String[] args) {
		StopwordRemoverImpl remover;
		StopwordReader stopwordReader = new StopwordReader(new File(GlobalParameters.STOP_WORD_LIST));
		TaggedTextSplitter TTSplitter = new TaggedTextSplitter();
		PhraseClustering pClustering = new PhraseClustering();

		remover = new StopwordRemoverImpl(stopwordReader.getStopwordMap());
		//					String[] content = HtmlTagHelper.contentToArray(file);
		String[] content = HtmlTagHelper.contentToArray(new File("resources/documents/tagged/toff-start-pa-hostferien-1.5708446.txt"));
		int i=0;
		//		for(String s: content){
		//			System.out.println(i);
		//			System.out.println(s);
		//			i++;
		//		}
		TaggerExtractor ntExtractor = new TaggerExtractor();
		ArrayList<String[]> contentArrayList = new ArrayList<String[]>();
		for(String part: content){
			if(part==null || part.isEmpty()){
				contentArrayList.add(null);
				continue;
			}
			//						System.out.println("PART: " + part);
			TTSplitter.split(part);
			String[] tags = TTSplitter.getTagArr();
			String[] text = TTSplitter.getTextArr();
			ntExtractor.addTags(tags);
			contentArrayList.add(text);
		}

		remover.cleanUp();
		//					String[] contentArray = HtmlTagHelper.contentToArray(file);
		//					for(String s: contentArray){
		//						System.out.println("LINE" +s);
		//					}
		//					ArrayList<String> fileStringArray = FileToString.readStringArrayFromFile(file.getAbsolutePath());
		//					remover.removeStopWords(fileStringArray.get(0), 1);
		//					remover.setWordDegrees(1.0);

		remover.removeStopWords(contentArrayList.get(0));
		if(GlobalParameters.weighted){
			if(GlobalParameters.lowWeight){
				remover.setWordDegrees(1.5);
			}
			else{
				remover.setWordDegrees(3.0);
			}

		}
		else{
			remover.setWordDegrees(1.0);
		}

		//Header
		remover.removeStopWords(contentArrayList.get(1));
		if(GlobalParameters.weighted){
			if(GlobalParameters.lowWeight){
				remover.setWordDegrees(2.5);
			}
			else{
				remover.setWordDegrees(5.0);
			}
		}
		else{
			remover.setWordDegrees(1.0);
		}

		//body
		remover.removeStopWords(contentArrayList.get(2));
		remover.setWordDegrees(1.0);


		remover.setRatio();
		remover.calculateRatioKeywords();

		HashSet<Phrase> keywords = remover.getKeywords();
		for(Phrase p: keywords){
			System.out.println(p.getPhraseToString() + " " + p.getScore());
		}
		//		System.out.println("MAIN, KEYWORD SIZE: " + keywords.size());
		//		List<String> entries = new ArrayList(keywords.entrySet());
		//		Collections.sort(entries, new EntryValueComparator());

		//		System.out.println(file.getName());

		String s = "";
		Phrase temp;

		List<Phrase> phrases = new ArrayList<Phrase>();				
		Iterator it = keywords.iterator();


		while ( it.hasNext() )
		{
			temp = (Phrase)it.next();
			if(ntExtractor.containsNoun(temp)){
				//				System.out.println(temp.getPhraseToString());
				phrases.add(temp);
			}
		}
		System.out.println("PHRASES");

		List<Phrase> topPhrases = new ArrayList<Phrase>();
		Collections.sort(phrases, new PhraseComparator());
		int topThird = (int)Math.floor(phrases.size()/3);
		for(int j=0;j<topThird;j++){
			topPhrases.add(phrases.get(j));
		}


		for(Phrase p: phrases){
			System.out.println(p.getPhraseToString());
			System.out.println(p.getScore());
		}
		System.out.println("TOPPHRASES");
		for(Phrase p: topPhrases){
			System.out.println(p.getPhraseToString());
			System.out.println(p.getScore());
		}
	}
}
