package unused;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;

public class TextFromUrlImpl {

	private String urlString;
	private String extractorUrlString = "http://slt.idi.ntnu.no:8080/WebOdIR/OstlendingenContentExtractorService?url=";

	private URL serverAdress;

	public String extractFromUrl(String url){
		this.urlString = extractorUrlString + url + "&submit=Submit";

		InputStream is = null;
		BufferedReader d;
		String s;
		String returnString="";

		try{
			serverAdress = new URL(urlString);
			
			 is = serverAdress.openStream();   // throws an IOException
			 
			 d = new BufferedReader(new InputStreamReader(is));


			 while ((s = d.readLine()) != null) {
//		            System.out.println(s);
		            returnString = returnString + s + "\n";
		         }

		}
		catch (Exception e) {

		}
		finally{
			try {
				if(is != null){
					is.close();
				}            
	         } catch (IOException ioe) {
	            ioe.printStackTrace();
	         }

		}


		return returnString;
	}
	
	public String[] removeHtmlTags(String text){
		String trimmedText;

//		Removing all html tags and the contentinfo in script and header
//		Html tags can also be removed with a method that removes anything between < and >.
		trimmedText = removeAllTags(text, "html");
		trimmedText = removeAllTags(trimmedText, "body");
		trimmedText = removeAllTags(trimmedText, "div");
		trimmedText = removeAllTags(trimmedText, "br");
		trimmedText = removeAllTags(trimmedText, "p");
		trimmedText = removeTagsAndContent(trimmedText, "script");
		trimmedText = removeTagsAndContent(trimmedText, "head");
		trimmedText = removeTagHeader(trimmedText, "p");
		trimmedText = removeTagHeader(trimmedText, "div");
		trimmedText = trimmedText.replaceAll("\n", " "); // Remove newlines
		trimmedText = trimmedText.replaceAll("[ ]{2,}"," "); // Remove multiple spaces	
		String[] returnString = new String[2];
		
		int start = trimmedText.indexOf("<strong>");
		int end = trimmedText.indexOf("</strong>");
//		returnString[0] = "<HEADER>" + trimmedText.substring(start+8, end) + "</HEADER>" ; //The header text
		returnString[0] = trimmedText.substring(start+8, end);
		returnString[1] = trimmedText.substring(end+9).trim(); //The body text
		return returnString;
	}
	
	public void removeTags(String text){
		text.replaceAll("<**>", "");
	}
	
	public String removeTagHeader(String text, String tag){
		String trimmedText;
		int start = text.indexOf("<"+tag);
		int end = text.indexOf(">", start);
		String substringFirst = text.substring(0, start);
		String subStringLast = text.substring(end + tag.length() + 1);
		trimmedText = substringFirst + subStringLast; 
		return trimmedText;
	}
	public String removeAllTags(String text, String tag){
		String trimmedText = text.replaceAll("<"+tag+">", "");
		trimmedText = trimmedText.replaceAll("</"+tag+">", "");
		return trimmedText;
	}
	
	public String removeTagsAndContent(String text, String tag){
		int start = text.indexOf("<"+tag);
		int end = text.indexOf("</"+tag+">");
		String substringFirst = text.substring(0, start);
		String subStringLast = text.substring(end + tag.length() + 3);
		String trimmedText = substringFirst + subStringLast; 
		return trimmedText;
	}
	
	public String getTitle(String url){
		String[] split = url.split("/");
		String title = split[split.length-1];
		title = title.substring(0, title.lastIndexOf("-"));
		title = title.replaceAll("-", " ");
		title = "<TITLE>" + title + "</TITLE>";
		return title;
	}

	public static void main(String[] args){
		TextFromUrlImpl test = new TextFromUrlImpl();
		String url = "http://www.ostlendingen.no/nyheter/gir-opp-tvinnlandet-1.4020497";
		String returnString =test.extractFromUrl(url);
		String[] returnStringTable = test.removeHtmlTags(returnString);
		String title = test.getTitle(url);
		System.out.println(title);
		for(String s: returnStringTable){
			System.out.println(s);	
		}
		
	}
	

}
