package util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

public class FileReaderHelper {

	public static List<String> readFileToStringList(File file){
		ArrayList<String> wordList = new ArrayList<String>();
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String aLine = br.readLine();
			while(aLine != null){
				String[] lineWords = aLine.split(" ");
				for(String s: lineWords){
					wordList.add(s);
				}
				aLine = br.readLine();
			}
		}
		catch(IOException e){
			e.printStackTrace();
		}
		return wordList;
	}
	
	public static HashSet<String> readFileToStringSet(File file){
		HashSet<String> wordList = new HashSet<String>();
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String aLine = br.readLine();
			while(aLine != null){
				String[] lineWords = aLine.split(" ");
				for(String s: lineWords){
					wordList.add(s);
				}
				aLine = br.readLine();
			}
		}
		catch(IOException e){
			e.printStackTrace();
		}
		return wordList;
	}

	public static String readFileToString(File file){
		String fileString = "";
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String aLine = br.readLine();
			while(aLine != null){
				fileString += aLine + "\n";
				aLine = br.readLine();
			}
		}
		catch(IOException e){
			e.printStackTrace();
		}
		return fileString;
	}

	public static File[] getFileListFromDirectory(File file){
		if(file==null){
			return null;
		}
		if(!file.isDirectory()) return null;
		return file.listFiles();
	}

	public static HashMap<String, String[]> readFileToHashMap(File file){
		HashMap<String, String[]> map = new HashMap<String, String[]>();
		try {
			String key;
			String value;
			
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String aLine = br.readLine();
			while(aLine != null){
				int last = aLine.lastIndexOf("=");
				key = aLine.substring(0, last);
				value = aLine.substring(last+1);
				if(map.containsKey(key)){
					String[] str = map.get(key);
					String[] newStr = new String[str.length+1];
					for(int i=0;i<str.length;i++){
						newStr[i] = str[i];
					}
					newStr[newStr.length-1] = value;
					map.put(key, newStr);
				}
				else{
					String[] str = new String[1];
					str[0] = value;
					map.put(key, str);
				}
				
				aLine = br.readLine();
			}
		}
		catch(IOException e){
			e.printStackTrace();
		}
		return map;
	}
	
	public static HashMap<String, String[]> readFileToReversedHashMap(File file){
		HashMap<String, String[]> map = new HashMap<String, String[]>();
		try {
			String key;
			String value;
			
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			String aLine = br.readLine();
			while(aLine != null){
				int last = aLine.lastIndexOf("=");
				value = aLine.substring(0, last);
				key = aLine.substring(last+1);
				if(map.containsKey(key)){
					String[] str = map.get(key);
					String[] newStr = new String[str.length+1];
					for(int i=0;i<str.length;i++){
						newStr[i] = str[i];
					}
					newStr[newStr.length-1] = value;
					map.put(key, newStr);
				}
				else{
					String[] str = new String[1];
					str[0] = value;
					map.put(key, str);
				}
				
				aLine = br.readLine();
			}
		}
		catch(IOException e){
			e.printStackTrace();
		}
		return map;
	}
}
