package util;

import java.io.File;

public class HtmlTagHelper {
	
	public static String formatTextWithHtmlTags(String text){
		String formatedText = "";
		int i=0;
		while(i>=0){
			int start=text.indexOf("<",i);
			int end = text.indexOf(">",i);
			if(start<0 || end<=0){
				formatedText += text.substring(i);
				i=-1;
			}
			else if(start>end){
				i=start+1;
				continue;
			}
			else{
				String tag = text.substring(start+1, end);
				formatedText += text.substring(i, start);
				formatedText += htmlTagToFormat(tag);
				i=end+1;
			}			
		}
		return formatedText;
	}
	
	public static String htmlTagToFormat(String tag){
		if(tag.equals("br")){
			return "\n";
		}
		else if(tag.equals("p")){
			return "\n";
		}
		else if(tag.equals("/p")){
			return "\n";
		}
		else if(tag.equals("strong")){
			return "*HEADER*";
		}
		else if(tag.equals("/strong")){
			return "*/HEADER*";
		}
		else return "";
	}
	
	public static String getStrongTaggedText(String text){
		StringBuilder formatedText = new StringBuilder();
		int i=0;
		while(i>=0){
			int start=text.toLowerCase().indexOf("<strong>",i);
			int end = text.toLowerCase().indexOf("</strong>",i);
			String s =formatTextWithHtmlTags(text.substring(start+"<strong>".length(), end));
			formatedText.append(s);
			i=end;
		}
		return formatedText.toString();
	}
	
	public static String[] contentToArray(String text){
		String[] contentArray = new String[3];
		contentArray[0] = addToArrayEntry("TITLE", text);
		contentArray[1] = addToArrayEntry("HEADER", text);
		int end = text.indexOf("*/HEADER*"); 
		end += "*/HEADER*".length();
		
		// to cover the line space between header and body text
		while(text.charAt(end)==' ' || text.charAt(end)=='\n'){ 
			end++;
		}
		contentArray[2] = text.substring(end);
		return contentArray;
	}
	
	public static String[] contentToArray(File file){
		String[] contentArray = new String[3];
		String text = FileReaderHelper.readFileToString(file);
		contentArray[0] = addToArrayEntry("TITLE", text);
		contentArray[1] = addToArrayEntry("HEADER", text);
		int end = text.indexOf("*/HEADER*"); 
		end += "*/HEADER*".length();
		
		// to cover the line space between header and body text
		while(text.charAt(end)==' ' || text.charAt(end)=='\n'){ 
			end++;
		}
		contentArray[2] = text.substring(end);
		return contentArray;
	}
	
	public static String[] adressaContentToArray(File file){
		String[] contentArray = new String[4];
		String text = FileReaderHelper.readFileToString(file);
		contentArray[0] = addToArrayEntry("TAGS", text);
		contentArray[1] = addToArrayEntry("TITLE", text);
		contentArray[2] = addToArrayEntry("HEADER", text);
		int end = text.indexOf("*/HEADER*"); 
		end += "*/HEADER*".length();
		
		// to cover the line space between header and body text
		while(text.charAt(end)==' ' || text.charAt(end)=='\n'){ 
			end++;
		}
		contentArray[3] = text.substring(end);
		return contentArray;
	}
	
	public static String contentToString(File file){
		String returnStr = "";
		String[] contentArray = contentToArray(file);
		for(String s: contentArray){
			returnStr = s + " ";
		}
		return returnStr;
	}
	
	private static String addToArrayEntry(String name, String text){
		int start = text.indexOf("*" + name + "*");
		String lenght = "*" + name + "*".length();
		start += lenght.length();
		int end = text.indexOf("*/" + name + "*");
		if(start<0 || end<0 || end<start){
			System.out.println("HTMLTAGHELPER.START " + start);
			System.out.println("HTMLTAGHELPER.END " + end);
			return "";
		}
		else{
			return text.substring(start, end);
		}
	}
	
	public static String removeTitleAndHeader(String text){
		text = text.replaceAll("\\*TITLE\\*", "");
		text = text.replaceAll("\\*/TITLE\\*", "");
		text = text.replaceAll("\\*HEADER\\*", "");
		text = text.replaceAll("\\*/HEADER\\*", "");
		text = text.replaceAll("\\s+", " ");
		return text;
	}

}
