package util;

public class StringHelper {
	
	public static String cleanString(String str){
		if(str==null || str.isEmpty()){
			return str;
		}
		str = str.trim();
		str = removeEndSymbol(str);
		str = removeStartSymbol(str);
		return str;
	}
	
	public static String removeEndSymbol(String str){
		if(str.isEmpty())return str;
		char last = str.charAt(str.length()-1);
		if(!Character.isLetterOrDigit(last)){
			return str.substring(0, str.length()-1);
		}
		return str;
	}
	
	public static String removeStartSymbol(String str){
		if(str.isEmpty())return str;
		char first = str.charAt(0);
		if(!Character.isLetterOrDigit(first)){
			return str.substring(1);
		}
		return str;
	}
	
	public static boolean containsBrackets(String str){
		return str.contains("<") || str.contains(">") ? true : false;
	}
	
	public static boolean isNorwegianLetter(String str){
		return str.matches("[a-zA-Z]");
	}
	
	public static boolean isUpperCase(String word){
		if(word.length()<1){
			return false;
		}
		char first = word.charAt(0);
		return Character.isUpperCase(first);
	}

	public static boolean isEndOfSentence(String word){
		if(word==null || word.isEmpty()) return false;
		char last = word.charAt(word.length()-1);
		return last=='.' || last=='!' || last==':' || last=='?' ? true : false;
	}
	
	public static boolean isEndOfPartSentenceorSentence(String word){
		return isEndOfPartSentence(word) || isEndOfSentence(word);
	}
	
	public static boolean isEndOfPartSentence(String word){
		if(word==null || word.isEmpty()) return false;
		char last = word.charAt(word.length()-1);
		return last==',' || last==';'  ? true : false;
	}
	
	public static boolean isColonOrSemicolon(Character cha){
		return isColon(cha) && isSemicolon(cha);
	}
	
	public static boolean isColon(Character cha){
		return cha.equals(':');
	}

	public static boolean isSemicolon(Character cha){
		return cha.equals(';');
	}
	
	public static boolean isComma(Character cha){
		return cha.equals(',');
	}
	
	public static boolean isCapitalLetters(String word){
		for(Character ch: word.toCharArray()){
			if(Character.isLowerCase(ch))
				return false;
		}
		return true;
	}
	
	public static boolean isNoLetters(String word){
		if(word==null) return true;
		for(Character ch: word.toCharArray()){
			if(Character.isLetter(ch))
				return false;
		}
		return true;
	}

	public static String removeByline(String str){
		str = str.replaceAll("\\$BYLINE_ON\\$", "");
		str = str.replaceAll("\\$BYLINE_OFF\\$", "");
		return str;
	}
	
	public static String removeWhiteSpace(String str){
		return str.replaceAll("\\s+", " ");
	}
	
	public static String preColonWordsToLowerCase(String str){
		int colonIndex = str.indexOf(":");
		while(colonIndex>-1){
			str = preColonWordToLowercase(str, colonIndex);
			colonIndex = str.indexOf(":",colonIndex+1);
		}
		return str;
	}
	
	private static String preColonWordToLowercase(String str, int colonIndex){
		int preWordIndex = colonIndex;
		while(preWordIndex>0 && (Character.isUpperCase(str.charAt(preWordIndex-1)) || Character.isWhitespace(str.charAt(preWordIndex-1)))){
			preWordIndex--;
		}
		String preString = str.substring(0, preWordIndex);
		String postString = str.substring(colonIndex);
		String wordString = str.substring(preWordIndex, colonIndex).toLowerCase();
		return preString+wordString+postString;
	}
	
	public static String removeRandomQuestionMarks(String str){
		System.out.println("REMOVING QUESTION MARKS FROM " + str);
//		str = "START" + str;
		int i=0;
		for (char ch : str.toCharArray()){
			if(Character.getNumericValue(ch)==-1 && Character.getType(ch)==0){
				System.out.println(Character.getType(ch));
				System.out.println("MJAUUUUUU" + i);
			}
			i++;
		}
		
		System.out.println(str.charAt(1315));
		System.out.println(Character.getType(1315));
		System.out.println(Character.getNumericValue(1315));
		
		int questionIndex = str.indexOf(" ? ");
		questionIndex = str.indexOf('?');
		int temp = questionIndex;
		
		System.out.println(questionIndex);
		while(questionIndex>-1){
			temp = questionIndex;
			while(Character.isWhitespace(str.charAt(temp-1))){
				System.out.println(str.substring(temp-2, temp-1));
				if(StringHelper.isEndOfPartSentenceorSentence(str.substring(temp-2, temp-1))){
					str=str.substring(0, questionIndex-1)+str.substring(questionIndex+1);
				}
				temp--;
			}
			questionIndex = str.indexOf("?", questionIndex+1);
		}
		return str;
	}
	
	public static String[] formatOperations(String str){
		String returnString = HtmlTagHelper.formatTextWithHtmlTags(str);
		returnString = removeByline(returnString);
		returnString = removeWhiteSpace(returnString);
//		returnString = preColonWordsToLowerCase(returnString);
//		returnString = returnString.replaceAll(":", ".");
//		returnString = removeRandomQuestionMarks(returnString);
//		System.out.println("START" + returnString);
//		System.out.println(returnString.charAt(1315));
//		char ch = returnString.charAt(1315);
//		System.out.println("CHAR VLAUE:" + Character.getNumericValue(ch));
		String[] fileStringArray = HtmlTagHelper.contentToArray(returnString);
		return fileStringArray;

	}
}
